Package com.datecs.fiscalprinter.SDK.model.BGR

# Class FP2000_BGR

java.lang.Object
com.datecs.fiscalprinter.SDK.FiscalPrinterV1
com.datecs.fiscalprinter.SDK.model.BGR.FP2000_BGR

    public class FP2000_BGR
    extends FiscalPrinterV1

- ## Field Summary

  ### Fields inherited from class com.datecs.fiscalprinter.SDK.FiscalPrinterV1

  `MAX_ADDITIONAL_PAYMENTS, transport`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `FP2000_BGR​(AbstractTransportProtocol protocol)` |
  `FP2000_BGR​(java.io.InputStream in, java.io.OutputStream out)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `FiscalResponse` | `command100Variant0Version0​(java.lang.String text)` | 64h (100) SHOW TEXT ON THE DISPLAY
  `FiscalResponse` | `command101Variant0Version0​(java.lang.String operatorCode, java.lang.String oldPassword, java.lang.String newPassword)` | 65h (101) SET AN OPERATOR PASSWORD Sets one of the sixteen operator passwords.
  `FiscalResponse` | `command102Variant0Version0​(java.lang.String operatorCode, java.lang.String operatorPass, java.lang.String operatorName)` | 66h (102) SET AN OPERATOR NAME
  `FiscalResponse` | `command103Variant0Version0()` | 67h (103) CURRENT RECEIPT INFORMATION
  `FiscalResponse` | `command105Variant0Version0()` | 68h (105) OPERATOR REPORT
  `FiscalResponse` | `command106Variant0Version0​(java.lang.String mSec)` | 6Ah (106) OPEN THE DRAWER
  `FiscalResponse` | `command107Variant0Version0()` | 6Bh (107) DEFINE AND READ PLUs
  `FiscalResponse` | `command107Variant10Version0()` | 6Bh (107) DEFINING AND READING ARTICLES Return data for the next found item non-zero sales.
  `FiscalResponse` | `command107Variant11Version0​(java.lang.String option, java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES Find a free (unprogrammed) item.
  `FiscalResponse` | `command107Variant12Version0​(java.lang.String PLU, java.lang.String price)` | 6Bh (107) DEFINING AND READING ARTICLES Set the price of an item
  `FiscalResponse` | `command107Variant1Version0​(java.lang.String taxGr, java.lang.String PLU, java.lang.String group, java.lang.String price, java.lang.String replaceQty, java.lang.String quantity, java.lang.String name)` | 6Bh (107) DEFINING AND READING ARTICLES (PLUs) Program a PLU.
  `FiscalResponse` | `command107Variant2Version0​(java.lang.String PLU, java.lang.String quantity)` | 6Bh (107) DEFINING AND READING ARTICLES (PLUs) Change the available quantity for an item.
  `FiscalResponse` | `command107Variant3Version0​(java.lang.String option, java.lang.String PLU, java.lang.String toPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLUs) Delete an item.
  `FiscalResponse` | `command107Variant4Version0​(java.lang.String PLU)` | 6Bh (107) DEFINING AND READING ARTICLES Read item data.
  `FiscalResponse` | `command107Variant5Version0​(java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLUs) Return data for the first programmed item PLU found.
  `FiscalResponse` | `command107Variant6Version0​(java.lang.String lastPLU)` | 6Bh (107) DEFINING AND READING ARTICLES (PLUs) Return the data for the last found programmed item.
  `FiscalResponse` | `command107Variant7Version0()` | 6Bh (107) DEFINING AND READING ARTICLES Return the data for the next found programmed item
  `FiscalResponse` | `command107Variant8Version0​(java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES Return the data for the first found item with non-zero sales
  `FiscalResponse` | `command107Variant9Version0​(java.lang.String startPLU)` | 6Bh (107) DEFINING AND READING ARTICLES Return data for the last found item non-zero sales.
  `FiscalResponse` | `command108Variant0Version0​(java.lang.String option)` | 6Ch (108) EXTENDED DAILY FINANCIAL REPORT The command has the same syntax as command 69 (45H), * but at the beginning of the daily report a report of * items for which there are sales for the day.
  `FiscalResponse` | `command109Variant0Version0​(java.lang.String count)` | 6Dh (109) PRINT A DUPLICATE RECEIPT
  `FiscalResponse` | `command110Variant0Version0()` | 6Eh (110) PAYMENT INFORMATION BY TYPE FOR THE DAY
  `FiscalResponse` | `command110Variant1Version0()` | 6Eh (110) PAYMENT INFORMATION BY TYPE FOR THE DAY All 11 additional payment types are returned.
  `FiscalResponse` | `command111Variant0Version0​(java.lang.String reportType, java.lang.String firstPLU, java.lang.String lastPLU, java.lang.String group)` | 6Fh (111) PLU (ARTICLE) REPORT
  `FiscalResponse` | `command112Variant0Version0​(java.lang.String operator)` | 70h (112) OBTAIN OPERATOR INFORMATION
  `FiscalResponse` | `command113Variant0Version0()` | 71h (113) OBTAIN THE LAST PRINTED DOCUMENT NUMBER
  `FiscalResponse` | `command114Variant0Version0​(java.lang.String Rec1)` | 72h (114) INFORMATION ON A FISCAL RECORD OR FISCAL PERIOD Information on the active tax rates for the Z-report record in question.
  `FiscalResponse` | `command114Variant10Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the total turnover and VAT up to the specified Z-report
  `FiscalResponse` | `command114Variant1Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the sales for the specified record or period
  `FiscalResponse` | `command114Variant1Version1​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Reversal (storno) information for the specified record or period.
  `FiscalResponse` | `command114Variant2Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on net amounts for the specified record or period.
  `FiscalResponse` | `command114Variant3Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the charged VAT for the specified record or period.
  `FiscalResponse` | `command114Variant4Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Additional information about the specified entry.
  `FiscalResponse` | `command114Variant5Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified entry from the fiscal memory for setting tax rates
  `FiscalResponse` | `command114Variant6Version0​(java.lang.String closure1)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified FP record with RAM reset.
  `FiscalResponse` | `command114Variant7Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period
  `FiscalResponse` | `command114Variant8Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period.
  `FiscalResponse` | `command114Variant9Version0​(java.lang.String closure1, java.lang.String closure2)` | 72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period.
  `FiscalResponse` | `command115Variant0Version0​(java.lang.String rowNum, java.lang.String data)` | 73h (115) GRAPHIC LOGO PROGRAMMING
  `FiscalResponse` | `command115Variant1Version0​(java.lang.String rowNum)` | 73h (115) GRAPHIC LOGO READING Returns the contents of the respective graphic line in hexadecimal form.
  `FiscalResponse` | `command117Variant0Version0​(java.lang.String N, java.lang.String reportType)` | 76h (118) DAILY FINANCIAL REPORT WITH DEPARTMENT The command is identical to 69 (45h) from the previous version, the only difference being that, at the top of the daily report, it additionally prints the departments having sales for the day and the PLUs with codes between 1 and 40, if they have sales.
  `FiscalResponse` | `command118Variant0Version0​(java.lang.String N, java.lang.String reportType)` | 76h (118) DAILY FINANCIAL REPORT WITH DEPARTMENT AND PLU PRINTING
  `FiscalResponse` | `command119Variant0Version0​(java.lang.String Flg, java.lang.String DT1, java.lang.String DT2)` | 77h (119) EJ OPERATIONS
  `FiscalResponse` | `command119Variant10Version0​(java.lang.String FirstDoc, java.lang.String LastDoc)` | 77h (119) EJ OPERATIONS Return structured information - First Line
  `FiscalResponse` | `command119Variant10Version1()` | 77h (119) EJ OPERATIONS Return structured information - Next Line
  `FiscalResponse` | `command119Variant11Version0​(java.lang.String StartDateTime, java.lang.String EndDateTime)` | 77h (119) EJ OPERATIONS Return structured information: Find the first document between StartDateTime and EndDateTime and return the first text line of structured information.
  `FiscalResponse` | `command119Variant11Version1()` | 77h (119) EJ OPERATIONS Return structured information: Return the next line of structured information
  `FiscalResponse` | `command119Variant1Version0​(java.lang.String Fnt, java.lang.String Flg, java.lang.String DT1, java.lang.String DT2)` | 77h (119) EJ OPERATIONS
  `FiscalResponse` | `command119Variant2Version0​(java.lang.String Flg, java.lang.String D1, java.lang.String D2)` | 77h (119) EJ OPERATIONS
  `FiscalResponse` | `command119Variant3Version0​(java.lang.String Fnt, java.lang.String Flg, java.lang.String D1, java.lang.String D2)` | 77h (119) EJ OPERATIONS
  `FiscalResponse` | `command119Variant4Version0​(java.lang.String Flg, java.lang.String Cl, java.lang.String D1, java.lang.String D2)` | 77h (119) EJ OPERATIONS
  `FiscalResponse` | `command119Variant5Version0​(java.lang.String Fnt, java.lang.String Flg, java.lang.String Cl, java.lang.String D1, java.lang.String D2)` | 77h (119) EJ OPERATIONS
  `FiscalResponse` | `command119Variant6Version1()` | 77h (119) EJ OPERATIONS Reading the next text line by EJ.
  `FiscalResponse` | `command119Variant7Version0​(java.lang.String Num)` | 77h (119) EJ OPERATIONS Returns information from EJ for Z-report with number Num.
  `FiscalResponse` | `command119Variant8Version0​(java.lang.String X)` | 77h (119) EJ OPERATIONS Information about EJ
  `FiscalResponse` | `command119Variant9Version0​(java.lang.String All)` | 77h (119) EJ OPERATIONS Check the validity of EJ or part of it.
  `FiscalResponse` | `command148Variant0Version0()` | 94H (148) Check recently recorded RRN code in fiscal printer with RRN from last transaction in payment terminal
  `FiscalResponse` | `command149Variant0Version0()` | 95H (149) Data for last transaction
  `FiscalResponse` | `command151Variant0Version0()` | 97H (151) Prints the last successful transaction
  `FiscalResponse` | `command152Variant0Version0()` | 98H (152) Read the date and time of the payment terminal The command is forbidden in an open fiscal receipt.
  `FiscalResponse` | `command153Variant0Version0​(java.lang.String DateTime)` | 99H (153) Setting date and time of payment terminal The command is forbidden in an open fiscal receipt.
  `FiscalResponse` | `command154Variant0Version0()` | 9AH (154) Test connection to a payment terminal * Checks whether the fiscal device is connected to a payment terminal.
  `FiscalResponse` | `command155Variant0Version0()` | 9BH (155) Number of entries in the payment terminal The command is forbidden in an open fiscal receipt.
  `FiscalResponse` | `command156Variant0Version0()` | 9CH (156) Payment terminal information Example: BluePad-50,0901900001,1.1.23.0,93800133,7 The command is forbidden in an open fiscal receipt.
  `FiscalResponse` | `command157Variant0Version0​(java.lang.String Batch)` | 9DH (157) Set batch number The command is forbidden in an open fiscal receipt
  `FiscalResponse` | `command158Variant0Version0()` | 9EH (158) Transaction status (unsuccessful) The command is forbidden in an open fiscal receipt
  `FiscalResponse` | `command159Variant0Version0()` | 9FH (159) Delete batch
  `FiscalResponse` | `command160Variant0Version0()` | A0H (160) Deleting (unsuccessful) freeze transactions
  `FiscalResponse` | `command161Variant0Version0​(java.lang.String Stan)` | A1H (161) Establishing a receipt number
  `FiscalResponse` | `command162Variant0Version0​(java.lang.String Num)` | A2H (162) Print a receipt by number
  `FiscalResponse` | `command163Variant0Version0()` | A3H (163) Printing the last successful transaction in a payment terminal
  `FiscalResponse` | `command164Variant0Version0()` | A4H (164) Return the last successful transaction
  `FiscalResponse` | `command165Variant0Version0()` | A5H (165) Establishment of RRN code in FD with RRN code from payment terminal It is used when changing the Fiscal Device and / or payment terminal.
  `FiscalResponse` | `command166Variant0Version0()` | A6H (166) Test connection to server The command is forbidden in an open fiscal receipt.
  `FiscalResponse` | `command167Variant0Version0()` | A7H (167) Closing of the day
  `FiscalResponse` | `command168Variant0Version0()` | A8H (168) Checking and updating of payment terminal software
  `FiscalResponse` | `command169Variant0Version0​(java.lang.String Type)` | A9H (169) Reports The command is forbidden in an open fiscal receipt.
  `FiscalResponse` | `command172Variant0Version0()` | ACH (172) Status of last transaction
  `FiscalResponse` | `command173Variant0Version0()` | ADH (173) Clearing transaction status flags
  `FiscalResponse` | `command174Variant0Version0​(java.lang.String Opt, java.lang.String NumReceipts)` | AEH (174) Header printing options The command is forbidden in an open fiscal receipt
  `FiscalResponse` | `command175Variant0Version0​(java.lang.String CpNum)` | AFH (175) Printing a copy of an receipt from the EJ
  `FiscalResponse` | `command175Variant0Version1​(java.lang.String CpDate)` | AFH (175) Printing a copy of an receipt from the EJ
  `FiscalResponse` | `command32Variant0Version0​(java.lang.String Clear)` | 20h (32) EXTENDED INFORMATION ON THE LAST ERROR The command allows to obtain information on the last command completed with an error.
  `FiscalResponse` | `command33Variant0Version0()` | 21h (33) CLEAR THE DISPLAY
  `FiscalResponse` | `command35Variant0Version0​(java.lang.String text)` | 23h (35) SHOW TEXT ON THE LOWER LINE OF THE DISPLAY
  `FiscalResponse` | `command36Variant0Version0​(java.lang.String IPAddr, java.lang.String SubnetMask, java.lang.String TCPPort, java.lang.String DefGateway, java.lang.String DHCP, java.lang.String MACAddr)` | 24H (36) LAN SETTINGS WRITING Data area: [IPAddr,SubnetMask,TCPPort,Gateway[,*DHCP][,MACAddr]] Response: [IPAddr,SubnetMask,TCPPort,Gateway,DHCP,MACAddr]
  `FiscalResponse` | `command36Variant1Version0()` | 24H (36) LAN SETTINGS READING
  `FiscalResponse` | `command37Variant0Version0()` | 25h (37) READ NRA DATA DT,Closure,FiscRec,LastFiscal,LastDoc,Journal
  `FiscalResponse` | `command37Variant1Version0()` | 25h (37) READ NRA DATA S1,S2,S3,S4,S5,S6,S7,S8,Total,GTotal
  `FiscalResponse` | `command37Variant2Version0()` | 25h (37) READ NRA DATA DiscountN,DiscountS,MarkUpN,MarkUpS,VoidN,VoidS,CancelN,CancelS
  `FiscalResponse` | `command37Variant3Version0()` | 25h (37) READ NRA DATA CashInN,CashInS,CashOutN,CashOutS,CashSum
  `FiscalResponse` | `command37Variant4Version0()` | 25h (37) READ NRA DATA CashPaid,CredPaid,CardPaid,CheckPaid,Payd1,Paid2,Paid3,Paid4
  `FiscalResponse` | `command37Variant5Version0​(java.lang.String Closure)` | 25h (37) READ NRA DATA Expects a daily report number and returns the daily report date and time.
  `FiscalResponse` | `command37Variant6Version0()` | 25h (37) READ NRA DATA Returns the date of fiscal registration or 'F,' if the printer is not placed into operation.
  `FiscalResponse` | `command37Variant7Version0​(java.lang.String Option)` | 25h (37) READ NRA DATA Returns PLU sales data by PLU codes in ascending order.
  `FiscalResponse` | `command38Variant0Version0()` | 26h (38) OPEN A SERVICE RECEIPT
  `FiscalResponse` | `command39Variant0Version0()` | 27h (39) CLOSE A SERVICE RECEIPT
  `FiscalResponse` | `command41Variant0Version0​(java.lang.String Switches)` | 29H (41) STORE THE SETTINGS AND THE SWITCHES IN THE FLASH MEMORY
  `FiscalResponse` | `command42Variant0Version0​(java.lang.String text)` | 2Ah (42) PRINT FREE TEXT IN A SERVICE RECEIPT
  `FiscalResponse` | `command42Variant1Version0​(java.lang.String text, java.lang.String font, java.lang.String flags)` | 2Ah (42) PRINT FREE TEXT IN A SERVICE RECEIPT
  `FiscalResponse` | `command43Variant0Version0​(java.lang.String itemIndex, java.lang.String itemText)` | 2Bh (43) SET THE HEADER, FOOTER AND PRINT OPTIONS
  `FiscalResponse` | `command43Variant1Version0​(java.lang.String printOption, java.lang.String value)` | 2Bh (43) PRINT OPTIONS - WRITE
  `FiscalResponse` | `command43Variant2Version0​(java.lang.String itemOption)` | 2Bh (43)PRINT OPTIONS - READ
  `FiscalResponse` | `command43Variant2Version1​(java.lang.String lineNumber)` | 2Bh (43) READ THE HEADER, FOOTER
  `FiscalResponse` | `command44Variant0Version0​(java.lang.String lines)` | 2Ch (44) FEED PAPER
  `FiscalResponse` | `command45Variant0Version0()` | 2Dh (45) PAPER CUT.
  `FiscalResponse` | `command46Variant0Version0​(java.lang.String OpNum, java.lang.String Password, java.lang.String TillNum, java.lang.String Invoice, java.lang.String InvNum, java.lang.String UNP, java.lang.String StType, java.lang.String DocNo, java.lang.String StUNP, java.lang.String StDT, java.lang.String StFMIN, java.lang.String StornoReason)` | 2E (46) ISSUE A REFUND (STORNO) RECEIPT
  `FiscalResponse` | `command47Variant0Version0​(java.lang.String text)` | 2F (47) SHOW TEXT ON THE UPPER LINE OF THE DISPLAY
  `FiscalResponse` | `command48Variant0Version0​(java.lang.String OpNum, java.lang.String Password, java.lang.String TillNum, java.lang.String UNP)` | 30h (48) OPEN A FISCAL (CUSTOMER) RECEIPT
  `FiscalResponse` | `command48Variant1Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String tillNmb, java.lang.String UNP)` | 30h (48) OPEN A FISCAL (CUSTOMER) RECEIPT -extended customer receipt (invoice)
  `FiscalResponse` | `command48Variant2Version0()` | 30h (48) Read sequential number of the sale from the Unique Sale ID of the last issued fiscal receipt is returned.
  `FiscalResponse` | `command48Variant2Version1()` | 30h (48) Sequential number of the sale from the Unique Sale ID Returns the global number of the last issued fiscal document and the Unique Sale ID (in the full format, example: DT000600-OP01-0001000) of the last issued fiscal receipt.
  `FiscalResponse` | `command48Variant2Version2()` | 30h (48) Checks are made as to whether a command 30h (48) will be passed.
  `FiscalResponse` | `command49Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc)` | 31h (49) ENTER A PRODUCT (SALE)
  `FiscalResponse` | `command49Variant0Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc)` | 31h (49) ENTER A PRODUCT (SALE) Percentage Mark-up / discount
  `FiscalResponse` | `command49Variant1Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum)` | 31h (49) ENTER A PRODUCT (SALE) Mark-up / discount on value
  `FiscalResponse` | `command49Variant1Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum)` | 31h (49) ENTER A PRODUCT (SALE) Mark-up / discount on value
  `FiscalResponse` | `command50Variant0Version0​(java.lang.String startDate, java.lang.String endDate)` | 32h (50) TAX RATES PERFORMED DURING THE RESPECTIVE PERIOD
  `FiscalResponse` | `command51Variant0Version0​(java.lang.String print, java.lang.String display)` | 33h (51) SUBTOTAL
  `FiscalResponse` | `command51Variant1Version0​(java.lang.String print, java.lang.String display, java.lang.String perc)` | 33h (51) SUBTOTAL
  `FiscalResponse` | `command51Variant2Version0​(java.lang.String print, java.lang.String display, java.lang.String absSum)` | 33h (51) SUBTOTAL Mark-up or discount by amount
  `FiscalResponse` | `command52Variant0Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc)` | 34h (52) ENTER AND DISPLAY mark-up or discount by a percentage
  `FiscalResponse` | `command52Variant0Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc)` | 34h (52) ENTER AND DISPLAY mark-up or discount by a percentage
  `FiscalResponse` | `command52Variant1Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum)` | 34h (52) ENTER AND DISPLAY
  `FiscalResponse` | `command52Variant1Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum)` | 34h (52) ENTER AND DISPLAY mark-up or discount by a amount
  `FiscalResponse` | `command53Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String paidMode, java.lang.String amount)` | 35h (53) TOTAL CALCULATION
  `FiscalResponse` | `command54Variant0Version0​(java.lang.String text)` | 36h (54) PRINT FREE FISCAL TEXT
  `FiscalResponse` | `command54Variant1Version0​(java.lang.String Font, java.lang.String Flags, java.lang.String Text)` | 36h (54) PRINT FREE FISCAL TEXT
  `FiscalResponse` | `command56Variant0Version0()` | 38h (56) CLOSING A FISCAL RECEIPT
  `FiscalResponse` | `command57Variant0Version0​(java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address)` | 39h (57) PRINT OF CUSTOMER INFORMATION
  `FiscalResponse` | `command57Variant1Version0​(java.lang.String bulstatType, java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address)` | 39h (57) PRINT OF CUSTOMER INFORMATION
  `FiscalResponse` | `command57Variant2Version0​(java.lang.String bulstatType, java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address, java.lang.String accPer)` | 39h (57) PRINT OF CUSTOMER INFORMATION Accountable Person
  `FiscalResponse` | `command58Variant0Version0​(java.lang.String display, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String UN, java.lang.String perc)` | 3Ah (58) REGISTRATION (SALE) OF ITEM (PLU) Percentage mark-up or discount
  `FiscalResponse` | `command58Variant0Version1​(java.lang.String D, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String UN, java.lang.String abs)` | 3Ah (58) REGISTRATION (SALE) OF ITEM Mark-up or discount by value
  `FiscalResponse` | `command60Variant0Version0()` | 3Ch (60) CANCEL (TERMINATE) A FISCAL RECEIPT
  `FiscalResponse` | `command61Variant0Version0​(java.lang.String date, java.lang.String time)` | 3Dh (61) SET THE DATE AND TIME A date before the last fiscal memory record date cannot be set.
  `FiscalResponse` | `command61Variant1Version0​(java.lang.String dateTime)` | 3Dh (61) SET THE DATE AND TIME
  `FiscalResponse` | `command62Variant0Version0()` | 3Eh (62) READ THE DATE AND TIME
  `FiscalResponse` | `command63Variant0Version0()` | 3Fh (63) DISPLAY THE DATE AND TIME
  `FiscalResponse` | `command64Variant0Version0​(java.lang.String Option)` | 40h (64) INFORMATION ON THE LAST FISCAL RECORD
  `FiscalResponse` | `command65Variant0Version0​(java.lang.String option)` | 41h (65) INFORMATION ON THE SUMS UNDER TAX GROUPS FOR THE DAY
  `FiscalResponse` | `command66Variant0Version0​(java.lang.String start, java.lang.String end)` | 42h (66) SET ALLOWABLE INVOICE NUMBER RANGE
  `FiscalResponse` | `command68Variant0Version0()` | 44h (68) NUMBER OF AVAILABLE FIELDS IN THE FISCAL MEMORY
  `FiscalResponse` | `command69Variant0Version0​(java.lang.String reportType)` | 45h (69) DAILY FINANCIAL REPORT clearing of accumulated data by operator
  `FiscalResponse` | `command70Variant0Version0​(java.lang.String amount)` | 46h (70) SERVICE MONEY DEPOSIT AND WITHDRAWAL
  `FiscalResponse` | `command71Variant0Version0()` | 47h (71) PRINT DIAGNOSTIC INFORMATION
  `FiscalResponse` | `command73Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String Start, java.lang.String End)` | 49h (73) FULL FISCAL MEMORY REPORT BY BLOCK NUMBER
  `FiscalResponse` | `command74Variant0Version0​(java.lang.String option)` | 4Ah (74) OBTAIN THE PRINTER STATUS
  `FiscalResponse` | `command74Variant1Version0()` | 4Ah (74) OBTAIN THE PRINTER STATUS
  `FiscalResponse` | `command74Variant2Version0()` | 4Ah (74) OBTAIN THE PRINTER STATUS
  `FiscalResponse` | `command74Variant3Version0()` | 4Ah (74) OBTAIN THE PRINTER STATUS
  `FiscalResponse` | `command75Variant0Version0​(java.lang.String Restore)` | 4Bh (75) FORCE SUPPRESSED PRINTING
  `FiscalResponse` | `command76Variant0Version0​(java.lang.String option)` | 4Ch (76) FISCAL TRANSACTION STATUS
  `FiscalResponse` | `command79Variant0Version0​(java.lang.String start, java.lang.String end)` | 4Fh (79) SHORT FISCAL MEMORY REPORT FROM DATE TO DATE
  `FiscalResponse` | `command80Variant0Version0​(java.lang.String hz, java.lang.String mSec)` | 50H (80) BEEP (TONE)
  `FiscalResponse` | `command80Variant1Version0​(java.lang.String SoundData)` | 50H (80) BEEP (TONE)
  `FiscalResponse` | `command81Variant1Version0()` | 51H (81) OBTAIN THE SUPPLY VOLTAGE AND TEMPERATURE
  `FiscalResponse` | `command83Variant0Version0​(java.lang.String multiplier, java.lang.String decimals, java.lang.String currency, java.lang.String enabledT, java.lang.String taxA, java.lang.String taxB, java.lang.String taxC, java.lang.String taxD, java.lang.String taxE, java.lang.String taxF, java.lang.String taxG, java.lang.String taxH)` | 53h (83) SET THE DECIMAL DIGITS, CURRENCY AND TAX RATES
  `FiscalResponse` | `command83Variant1Version0()` | 53h (83) READING OF DECIMALS, CURRENCY AND TAX RATES
  `FiscalResponse` | `command84Variant0Version0​(java.lang.String Type, java.lang.String Align, java.lang.String AllowN, java.lang.String AllowD, java.lang.String Data)` | 54H (84) BARCODE PRINT
  `FiscalResponse` | `command85Variant0Version0​(java.lang.String option, java.lang.String name)` | 55H (85) SET THE ADDITIONAL PAYMENT NAMES
  `FiscalResponse` | `command85Variant1Version0​(java.lang.String option)` | 55H (85) READ THE ADDITIONAL PAYMENT NAMES
  `FiscalResponse` | `command86Variant0Version0()` | 56H (86) READ THE DATE OF THE LAST RECORD IN THE FISCAL MEMORY
  `FiscalResponse` | `command86Variant1Version0()` | 56H (86) READ THE DATE OF THE LAST RECORD IN THE FISCAL MEMORY
  `FiscalResponse` | `command87Variant0Version0​(java.lang.String dept, java.lang.String taxGr, java.lang.String line1, java.lang.String line2)` | 57H (87) PROGRAM A DEPARTMENT NAME The command can be executed only if no fiscal receipts for the department have been issued after the last Z-report.
  `FiscalResponse` | `command88Variant0Version0​(java.lang.String dept)` | 58H (88) OBTAIN DATA ON THE ACCUMULATED SUMS FOR A DEPARTMENT
  `FiscalResponse` | `command90Variant0Version0​(java.lang.String option)` | 5Ah (90) READING DIAGNOSTIC INFORMATION
  `FiscalResponse` | `command92Variant0Version0​(java.lang.String type)` | 5Ch (92) PRINT A DIVIDER LINE
  `FiscalResponse` | `command92Variant1Version0​(java.lang.String type)` | 5Ch (92) SEPARATION ON A DISTRIBUTION LINE The command is supported only in service receipts!
  `FiscalResponse` | `command93Variant1Version0()` | 5Dh (93) OBTAIN INFORMATION ON THE DISCOUNTS AND MARK-UPS FOR THE DAY
  `FiscalResponse` | `command94Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate, java.lang.String endDate)` | 5Eh (94) FULL FISCAL MEMORY REPORT BY FISCAL RECORD DATE
  `FiscalResponse` | `command94Variant1Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate)` | 5Eh (94) FULL FP REPORT BY DATE MONTHLY OR ANNUALLY
  `FiscalResponse` | `command95Variant0Version0​(java.lang.String first, java.lang.String last)` | 5Fh (95) SHORT FISCAL MEMORY REPORT FOR A PERIOD
  `FiscalResponse` | `command97Variant0Version0()` | 61h (97) READ THE SET TAX RATES
  `FiscalResponse` | `command99Variant0Version0()` | 63h (99) READ THE UIC
  `boolean` | `getCapAutoCutter()` |
  `boolean` | `getcapFontSupported()` |
  `int` | `getLogoROW_NUM()` |
  `int` | `getMaxBarcodeHeight_mm()` |
  `int` | `getMaxFooterLines()` |
  `int` | `getMaxHeaderLines()` |
  `int` | `getMaxLinesToFeed()` |
  `int` | `getMaxLogoHeightPixel()` |
  `int` | `getMaxLogoWidthPixel()` |
  `int` | `getMaxNonFiscalText()` |
  `int` | `getMinBarcodeHeight_mm()` |
  `int` | `getPrintColumns()` |
  `boolean` | `isPaperCuttingDevice()` |

  ### Methods inherited from class com.datecs.fiscalprinter.SDK.FiscalPrinterV1

  `close, customCommand, getCriticalStatuses, getDefaultOpCode, getDefaultOpPass, getDefaultTillNumber, getInfo, getIsCriticalStatus, getLastStatus, getMAX_DEPARTMENT, getMAX_PLU, getMAX_PRICE, getMaxDisplayText, getMaxOperators, getMaxStockGroup, getMsgSeparator, getStatusBitBol, getStatusBitDescription, isAutoCutInputParams, isChkInputParams, isThrowErrorMessage, notDbl, notInt, queryStatus, setAutoCutInputParams, setChkInputParams, setCriticalStatuses, setDebugLevel, setMsgSeparator, setThrowErrorMessage, toDouble, toInt`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### FP2000_BGR

    public FP2000_BGR​(java.io.InputStream in, java.io.OutputStream out) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Parameters:
      `in` -
      `out` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### FP2000_BGR

    public FP2000_BGR​(AbstractTransportProtocol protocol) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Parameters:
      `protocol` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

- ## Method Details

  - ### command32Variant0Version0

    public FiscalResponse command32Variant0Version0​(java.lang.String Clear) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    20h (32) EXTENDED INFORMATION ON THE LAST ERROR The command allows to obtain information on the last command completed with an error. This information is saved for successfully completed commands and also after the printer is powered off. It is cleared only on RAM reset and on execution of the command with a "CLEAR" text input. An error code list is provided at the end of the documentation. The command returns a result for any input.
    Specified by:
      `command32Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Clear` - - Fixed text contents: "CLEAR".
    Returns:
      - ErrCode - Number: error code. DateTime - Error date and time in the DD-MM-YY hh:mm:ss format. ErrText - Text description of the last error.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command33Variant0Version0

    public FiscalResponse command33Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    21h (33) CLEAR THE DISPLAY
    Specified by:
      `command33Variant0Version0` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command35Variant0Version0

    public FiscalResponse command35Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    23h (35) SHOW TEXT ON THE LOWER LINE OF THE DISPLAY
    Specified by:
      `command35Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `text` - Text, up to 20 characters, sent directly to the display. Before the text, a lower line positioning and clearing command is sent.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command36Variant0Version0

    public FiscalResponse command36Variant0Version0​(java.lang.String IPAddr, java.lang.String SubnetMask, java.lang.String TCPPort, java.lang.String DefGateway, java.lang.String DHCP, java.lang.String MACAddr) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    24H (36) LAN SETTINGS WRITING Data area: [IPAddr,SubnetMask,TCPPort,Gateway[,*DHCP][,MACAddr]] Response: [IPAddr,SubnetMask,TCPPort,Gateway,DHCP,MACAddr]
    Specified by:
      `command36Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `IPAddr` - 4 numbers, between 0 and 255, separated by a dot, representing the IP address of the device.
      `SubnetMask` - 4 numbers, between 0 and 255, separated by a dot, representing the Subnet mask of the device.
      `TCPPort` - Number, between 1 and 65535, representing the IP port of the device.
      `DefGateway` - 4 numbers, between 0 and 255, separated by a dot, representing the Default Gateway address of the device.
      `DHCP` - One character: "0" or "1". Enables or disables DHCP (Receiving automatic LAN settings from the server).
      `MACAddr` - Up to 12 hexadecimal characters representing the MAC address of the device. Works only if the service jumper is present!!!
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command36Variant1Version0

    public FiscalResponse command36Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    24H (36) LAN SETTINGS READING
    Specified by:
      `command36Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - IPAddr - 4 numbers, between 0 and 255, separated by a dot, representing the IP address of the device. SubnetMask - 4 numbers, between 0 and 255, separated by a dot, representing the Subnet mask of the device. TCPPort - Number, between 1 and 65535, representing the IP port of the device. DefGateway - 4 numbers, between 0 and 255, separated by a dot, representing the Default Gateway address of the device. DHCP - One character: "0" or "1". Enables or disables DHCP (Receiving automatic LAN settings from the server). MACAddr - Up to 12 hexadecimal characters representing the MAC address of the device. Works only if the service jumper is present!!!
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant0Version0

    public FiscalResponse command37Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA DT,Closure,FiscRec,LastFiscal,LastDoc,Journal
    Specified by:
      `command37Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - DT- String. Date and time in the "DD-MM-YYYY hh:mm:ss" format Closure- Integer. Next daily report number FiscRec- Integer. Number of fiscal receipts (customers) for the day LastFiscal- Integer. Global number of the last issued fiscal receipt. LastDoc- Integer. Global number of the last issued document. Journal- Integer. Current journal number
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant1Version0

    public FiscalResponse command37Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA S1,S2,S3,S4,S5,S6,S7,S8,Total,GTotal
    Specified by:
      `command37Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - Sx - Decimal number. Sales for a tax group, for the day. Total - Decimal number. Total sales for the day. GTotal - Decimal number. Total lifetime sales.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant2Version0

    public FiscalResponse command37Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA DiscountN,DiscountS,MarkUpN,MarkUpS,VoidN,VoidS,CancelN,CancelS
    Specified by:
      `command37Variant2Version0` in class `FiscalPrinterV1`
    Returns:
      - DiscountN - Integer. Number of discounts for the day. DiscountS - Decimal number. Total amount of discounts for the day. MarkUpN - Integer. Number of mark-ups for the day. MarkUpS - Decimal number. Total amount of mark-ups for the day. VoidN - Integer. Number of adjustments for the day. VoidS - Decimal number. Total amount of adjustments for the day. CancelN - Integer. Number of cancelled receipts for the day. CancelS - Decimal number. Total amount of cancelled receipts for the day
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant3Version0

    public FiscalResponse command37Variant3Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA CashInN,CashInS,CashOutN,CashOutS,CashSum
    Specified by:
      `command37Variant3Version0` in class `FiscalPrinterV1`
    Returns:
      - CashInN - Integer. Number of service deposit operations for the day. CashInS - Decimal number. Total amount of service deposits for the day. CashOutN - Integer. Number of service withdrawal operations for the day. CashOutS - Decimal number. Total amount of service withdrawals for the day. CashSum - Decimal number. Available cash.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant4Version0

    public FiscalResponse command37Variant4Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA CashPaid,CredPaid,CardPaid,CheckPaid,Payd1,Paid2,Paid3,Paid4
    Specified by:
      `command37Variant4Version0` in class `FiscalPrinterV1`
    Returns:
      - CashPaid - Decimal number. Paid in cash. CredPaid - Decimal number. Paid by credit card. CardPaid - Decimal number. Paid by debit card. CheckPaid - Decimal number. Paid by check. Paid1 - Decimal number. Paid by programmed payment type 1. Paid2 - Decimal number. Paid by programmed payment type 2. Paid3 - Decimal number. Paid by programmed payment type 3. Paid4 - Decimal number. Paid by programmed payment type 4.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant5Version0

    public FiscalResponse command37Variant5Version0​(java.lang.String Closure) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA Expects a daily report number and returns the daily report date and time. Returns 'F', if the record has an invalid checksum. Returns 'E', if no such record exists.
    Specified by:
      `command37Variant5Version0` in class `FiscalPrinterV1`
    Parameters:
      `Closure` - -
    Returns:
      - String. Date - and time in the "DD-MM-YYYY" Time - "hh:mm:ss" format.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant6Version0

    public FiscalResponse command37Variant6Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA Returns the date of fiscal registration or 'F,' if the printer is not placed into operation.
    Specified by:
      `command37Variant6Version0` in class `FiscalPrinterV1`
    Returns:
      - String. Date - and time in the "DD-MM-YYYY" Time - "hh:mm:ss" format.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command37Variant7Version0

    public FiscalResponse command37Variant7Version0​(java.lang.String Option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    25h (37) READ NRA DATA Returns PLU sales data by PLU codes in ascending order.
    Specified by:
      `command37Variant7Version0` in class `FiscalPrinterV1`
    Parameters:
      `Option` - - The command is first sent once using command Option "F" and then, the required number of times using command Option "N" until the printer returns the "F" response (no data) or we have read the required number of PLUs. The PLU name is always returned encoded in codepage 1251.
    Returns:
      - PLU - PLU code. 9 digits. PluTotal - Accumulated sales sum for the PLU. Decimal number. PluName - PLU name. Up to 36 characters.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command38Variant0Version0

    public FiscalResponse command38Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    26h (38) OPEN A SERVICE RECEIPT
    Specified by:
      `command38Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      _ Allreceipt - The number of all issued receipts (fiscal and service) since the last closing time until now (4 bytes). The FP carries out the following actions: Prints a HEADER. Prints the seller's UIC. Returns a response containing Allreceipt. The command can not be executed, if: -The fiscal memory is not formatted. -There is an open fiscal receipt. -A service receipt has already been opened. -The clock is not set
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command39Variant0Version0

    public FiscalResponse command39Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    27h (39) CLOSE A SERVICE RECEIPT
    Specified by:
      `command39Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      Allreceipt The number of all issued receipts (fiscal and service) since the last closing time until now (4 bytes). The FP carries out the following actions: -Prints a FOOTER. -Prints the document sequential number, date and time. -Prints "SERVICE RECEIPT" in wide letters. -Returns a response containing Allreceipt. -If S1.1 is raised, the command is not executed, because there is no open service receipt at this time.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command41Variant0Version0

    public FiscalResponse command41Variant0Version0​(java.lang.String Switches) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    29H (41) STORE THE SETTINGS AND THE SWITCHES IN THE FLASH MEMORY

    The printer has no hardware switches and uses an area in the flash memory for this purpose. They are set using this command. Additionally, the command stores the logo graphic, barcode length, print density and open-drawer pulse length in the flash memory. After a RAM reset, their values are restored for the flash memory. If only 8 bytes are submitted, the upper 8 remain unchanged. If the command has no data, the old values of the "switches" are kept and the remaining data are stored. The command stores the following data in the flash memory: - Header and footer (from command 43). - The text of the additional payment types (from command 85). - The logo graphic (from command 115). - The print options (from command 43). - The configuration switches. After a RAM reset, their values are restored for the flash memory.

    Specified by:
      `command41Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Switches` - - Switches 8 or 16 bytes with values of '0' or '1': the configuration "switches."
    Returns:
      - Result - ErrCode "P" - successful recording; "F" - unsuccessful recording of the settings.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command42Variant0Version0

    public FiscalResponse command42Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Ah (42) PRINT FREE TEXT IN A SERVICE RECEIPT
    Specified by:
      `command42Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `text` - Free text to print. The '#' character is printed at the start and the end of the line. The text may be with any length, but only the characters fitting on the line are used (without raising a truncation error).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command42Variant1Version0

    public FiscalResponse command42Variant1Version0​(java.lang.String text, java.lang.String font, java.lang.String flags) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Ah (42) PRINT FREE TEXT IN A SERVICE RECEIPT
    Specified by:
      `command42Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `text` - Free text to print. The '#' character is printed at the start and the end of the line. The text may be with any length, but only the characters fitting on the line are used (without raising a truncation error).
      `font` - Font Integer between 0 and 3: 0 32 dots (4 mm) height, higher letters 1 32 dots (4 mm) height, normal letters 2 24 dots (3 mm) height 3 16 dots (2 mm) height
      `flags` - Between one and 3 letters: 'B', 'H' or 'I'. Each may appear only once. Setting, respectively: B Bold (strong) H High (double heigh I Italic
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant0Version0

    public FiscalResponse command43Variant0Version0​(java.lang.String itemIndex, java.lang.String itemText) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) SET THE HEADER, FOOTER AND PRINT OPTIONS

    The HEADER contains 6 lines of text printed at the top of each fiscal or service receipt. The normal operation of the printer requires at least 2 Header lines to be set. The UIC (set by command 98) is always printed on the third line, therefore, the HEADER lines after line two are automatically moved down a line. The FOOTER contains 2 lines of text printed at the bottom of each receipt. The HEADER and FOOTER are centred automatically. This command needs to be executed up to 8 times to set all HEADER and FOOTER lines.

    Specified by:
      `command43Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `itemIndex` - One character with the following meaning:. '0' to '7' is the number of the line being set. The HEADER lines have numbers between 0 and 5, the FOOTER linesâ€”6 and 7.
      `itemText` - Text, up to 48 characters, where the text on the respective line.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant1Version0

    public FiscalResponse command43Variant1Version0​(java.lang.String printOption, java.lang.String value) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) PRINT OPTIONS - WRITE
    Specified by:
      `command43Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `printOption` - 'A' Automatic invoice-like sales formatting (4 separate lines). 'B' Sets the barcode height in pixels (0.125 mm). The possible values are between 24 (3 mm) and 240 (30 mm). The barcode is printed using command 84 (54H). 'C' Enable/disable automatic paper cut after each document. After the printer is powered on, the printer behaviour is controlled by switch Sw8. 'D' Sets the print density. Possible values: '1': Very light '2': Light '3': Normal '4': Dense '5': Very dense 'E' Enable/disable printing the total amount in EUR after the first payment command (53) in a fiscal receipt. Printing is disabled by default. Optionally, the command also sets the valid EUR/BGN exchange rate. Data syntax: [Enable][,Rate] Enable Print enable/disable flag. One byte: '0' or '1'. Rate Exchange rate. Floating-point number with up to 8 significant and 5 decimal digits. If it is omitted, the old value is kept. If it is 0.00000, no value in euros is printed, even if Enable is set. 'F' Set the printer font. Possible values: 0 32 dots (4 mm) height, higher letters 1 32 dots (4 mm) height, normal letters 2 24 dots (3 mm) height 'G' Enables / disables the printer's readiness print message. 'H' Enable / disable automatic Z-report printing at 23:59:59 o'clock if issuance of a fiscal or service entry for the day. Syntax: H[Enable][Options] Enable '0' or '1': Disable or enable automatic Z-report printing at 23:59:59 o'clock if issuance of a fiscal or service entry for the day. Options is a series of letters with a possible value: 'p': The Z-report is printed (otherwise it is only recorded in the KLEN); 'a': Z-report contains data for sales of articles / fuels; 'd': The Z-report contains departments data; 'N': The Z-report does not reset the operator data; 'A': The Z-report does not reset the item data; 'D': The Z-report does not reset the departments data. Each of the options can be present only once. 'K' Enable / disable UNP printing of fiscal and reversal receipts. _ Fiscal printer programming interface Version 2.00BG DATECS FP-800 / FP-2000 / FP-650 / SK1-21F / SK1-31F/ FMP-10 / FP-700 'L' Enable/disable printing the logo graphic right before the HEADER. The logo is set using command 115. The Text data are in the [Enable],[H] format. H is the logo height in pixels, Enable is one byte with a value of '1' (enabled) or '0' (disabled). 'M' Enable / disable the sound signal when attaching / disconnecting to the device on TCP / IP. 'N' Enable/disable printing the department name at the top of each fiscal receipt. 'Q' Enable/disable suppressed printing in a fiscal or service receipt. The data are in the Q0 or Q1,Lines,Seconds format. Q0 disables accumulation of unprinted lines in the receipt. Q1 enables accumulation of unprinted lines in the receipt. Printing starts when any of the following conditions is true: - Accumulation of the number of unprinted lines set in Lines. Lines can be between 4 and 1000 or 0. If the value is 0, printing starts when the print buffer is full. - The number of Seconds has passed without any new print line added. Seconds can be between 2 and 120 or 0. If the value is 0, there is no time limit. - The receipt is closed. - The printer is powered off and then back on. - Command 75 is executed. 'V' Enable / disable 2G forced modem operation (for 3G models) - one byte of '1' (enabled) or '0' (disabled). 'R' Sets the additional letter spacing in pixels (0.125 mm) in a 90-degree rotated service receipt. The possible values are between 0 and 4. 'SIM' Selects the SIM card to be used by the GPRS modem. The value can be either 0 or 1. 'T' Enable/disable printing accumulated VAT for the receipt in a normal (not extended) fiscal receipt. 'X' Enable/disable automatic generation of an open-drawer pulse for commands 53 (35H) and 70 (46H). 'W' Sets the time to trigger the warning for unsent data on payment documents and not updated data on the level measuring system. Printed as a service receipt (immediately after closing a fiscal receipt), which is not stored in the electronic journal. 'b' Sets the PIN and name under which the device is announced for Bluetooth. / for FMP10 / 'c' Disable/enable the FEED button functionality ('1': disabled, '0': enabled). After the printer is powered on, the button functionality is always enabled. 'd' Disable/enable returning optional text in the command response when an error occurs ('0': disabled, '1': enabled). 'P' Enable / disable automatic roll-up of paper in a container after each document. After turning on the printer, the printer does not pick up the paper in a container. (Printers SK1-21F and SK1-31F) 'O' Set time to automatically retract paper in a container after each printed and waiting to takeout document. (Printers SK1-21F and SK1-31F) '^' Set the type of voucher generation (0 - normal print document, 1- electronic document without print). This option works only for devices registered as type 21 / E-shop /.
      `value` - Depend of printOption
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant2Version0

    public FiscalResponse command43Variant2Version0​(java.lang.String itemOption) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43)PRINT OPTIONS - READ
    Specified by:
      `command43Variant2Version0` in class `FiscalPrinterV1`
    Parameters:
      `itemOption` - 'I' Allows reading the values previously set using command 43. Following the letter 'I', there is exactly one other character matching one of the above.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command43Variant2Version1

    public FiscalResponse command43Variant2Version1​(java.lang.String lineNumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Bh (43) READ THE HEADER, FOOTER
    Specified by:
      `command43Variant2Version1` in class `FiscalPrinterV1`
    Parameters:
      `lineNumber` - - '0' to '7' is the number of the line to be read. HEADER lines are numbered 0 to 5, and FOOTER lines are 6 and 7.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command44Variant0Version0

    public FiscalResponse command44Variant0Version0​(java.lang.String lines) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Ch (44) FEED PAPER
    Specified by:
      `command44Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `lines` - Lines The number of lines to feed the paper. Must be a positive number, at least 99 (1 or 2 bytes). Ifthe parameter is missing, the default 1 line is used.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command45Variant0Version0

    public FiscalResponse command45Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2Dh (45) PAPER CUT.
    Specified by:
      `command45Variant0Version0` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command46Variant0Version0

    public FiscalResponse command46Variant0Version0​(java.lang.String OpNum, java.lang.String Password, java.lang.String TillNum, java.lang.String Invoice, java.lang.String InvNum, java.lang.String UNP, java.lang.String StType, java.lang.String DocNo, java.lang.String StUNP, java.lang.String StDT, java.lang.String StFMIN, java.lang.String StornoReason) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2E (46) ISSUE A REFUND (STORNO) RECEIPT
    Specified by:
      `command46Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `OpNum` - -Operator ID (between 1 and 16)
      `Password` - -Operator password (between 4 and 8 digits)
      `TillNum` - -Cash register location number (integer between 1 and 99999)
      `Invoice` - -One "I" character. When present, an extended reversal customer receipt (credit note) will be printed. After the HEADER, the invoice number will be printed automatically and then, after the first payment commandâ€”a printout of the sums by tax group. After the payment, customer information must be printed using command 57 (39h).
      `InvNum` - -Number of invoice being reversed.
      `UNP` - -Unique Sale ID (format: FD Serial Number-four digits or Latin letters-sequential number of the sale (seven digits with leading zeroes), for example: DT000600-OP01-0001000). When opening a sales receipt for the first time, the UNP ( Unique Sale ID) must be set at least once, if the parameter is then omitted, the FU will increment the unit by the sale number automatically.
      `StType` - -Reversal reason by type: E: operator error R: return/claim T: tax base reduction
      `DocNo` - -(Global) number of the document being reversed.
      `StUNP` - -Unique Sale ID of the document being reversed. The whole Unique Sale ID must be set.
      `StDT` - -Date and time of the reversed document. Format "DDMMYYhhmmss"
      `StFMIN` - -Fiscal Memory ID of the FD which has issued the receipt being reversed.
      `StornoReason` - -Reversal reason by text (up to 30 characters).
    Returns:
      - Allreceipt - The number of all issued receipts (fiscal and service) since the last closing time until now. (4 bytes). StornoReceipt -The number of all fiscal receipts since the last closing time until now. (4 bytes).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException` - Note: If the last argument is DocNo and there are no other arguments, the FD searches for the issued receipt in its journal. If it is not found, the command fails. If it is found, the data are filled in automatically and a reversal receipt is issued with all the data from the original fiscal receipt. If StUNP, StDT, StFMIN are submitted, the command will be accepted only as an opening of a reversal receipt which needs to have sales and payments entered and then needs to be closed (similar to command 48).

  - ### command47Variant0Version0

    public FiscalResponse command47Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    2F (47) SHOW TEXT ON THE UPPER LINE OF THE DISPLAY
    Specified by:
      `command47Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `text` - Text, up to 20 characters, sent directly to the display. Before the text, an upper line positioning and clearing command is sent. The command is rejected, if a fiscal receipt is open and Sw1 is OFF.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### getMaxLinesToFeed

    public int getMaxLinesToFeed()
    Specified by:
      `getMaxLinesToFeed` in class `FiscalPrinterV1`

  - ### command48Variant0Version0

    public FiscalResponse command48Variant0Version0​(java.lang.String OpNum, java.lang.String Password, java.lang.String TillNum, java.lang.String UNP) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    30h (48) OPEN A FISCAL (CUSTOMER) RECEIPT
    Specified by:
      `command48Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `OpNum` - Operator ID (between 1 and 16)
      `Password` - Operator password (between 4 and 8 digits)
      `TillNum` - Cash register location number (integer between 1 and 99999)
      `UNP` - Unique Sale ID (format: FD Serial Number-four digits or Latin letters-sequential number of the sale (seven digits with leading zeroes), for example: DT000600-OP01-0001000). When opening a sales receipt for the first time, the UNP ( Unique Sale ID) must be set at least once, if the parameter is then omitted, the FU will increment the unit by the sale number automatically
    Returns:
      _ Allreceipt - The number of all issued receipts (fiscal and service) since the last closing time until now. (4 bytes)

      FiscReceipt - The number of all fiscal receipts since the last closing time until now. (4 bytes).

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant1Version0

    public FiscalResponse command48Variant1Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String tillNmb, java.lang.String UNP) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    30h (48) OPEN A FISCAL (CUSTOMER) RECEIPT -extended customer receipt (invoice)
    Specified by:
      `command48Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `opCode` - Operator ID (between 1 and 16)
      `opPwd` - Operator password (between 4 and 8 digits)
      `tillNmb` - Cash register location number (integer between 1 and 99999)
      `UNP` - Unique Sale ID (format: FD Serial Number-four digits or Latin letters-sequential number of the sale (seven digits with leading zeroes), for example: DT000600-OP01-0001000). When opening a sales receipt for the first time, the UNP ( Unique Sale ID) must be set at least once, if the parameter is then omitted, the FU will increment the unit by the sale number automatically.
    Returns:
      _ Allreceipt - The number of all issued receipts (fiscal and service) since the last closing time until now. (4 bytes)

      FiscReceipt - The number of all fiscal receipts since the last closing time until now. (4 bytes).

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant2Version0

    public FiscalResponse command48Variant2Version0() throws java.io.IOException, FiscalException
    30h (48) Read sequential number of the sale from the Unique Sale ID of the last issued fiscal receipt is returned. (example: 0001000).

    Specified by:
      `command48Variant2Version0` in class `FiscalPrinterV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant2Version1

    public FiscalResponse command48Variant2Version1() throws java.io.IOException, FiscalException
    30h (48) Sequential number of the sale from the Unique Sale ID Returns the global number of the last issued fiscal document and the Unique Sale ID (in the full format, example: DT000600-OP01-0001000) of the last issued fiscal receipt.

    If the last issued document was a Storno document, there would be another field of the Unique Sale ID on the document that was refunded. (example: 398554, DT000601-0001-0398101, DT000601-0001-0203305)

    Specified by:
      `command48Variant2Version1` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant2Version2

    public FiscalResponse command48Variant2Version2() throws java.io.IOException, FiscalException
    30h (48) Checks are made as to whether a command 30h (48) will be passed. *

    Specified by:
      `command48Variant2Version2` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant0Version0

    public FiscalResponse command49Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) ENTER A PRODUCT (SALE)

    Percentage Mark-up / discount

    Specified by:
      `command49Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `taxCd` - One byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded from FU to the specified number of decimal places and also should not exceed 8 significant digits.
      `UN` - Unit name. Optional text for unit of quantity up to 8 symbols, for example "kg".
      `perc` - Parameter showing the value of the surcharge or discount (depending on characters) as a percentage of current sales. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant1Version0

    public FiscalResponse command49Variant1Version0​(java.lang.String L1, java.lang.String L2, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) ENTER A PRODUCT (SALE) Mark-up / discount on value
    Specified by:
      `command49Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `taxCd` - One byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded off by FU
      `UN` - Unit name. Optional text for unit of quantity up to 8 symbols, such as "kg". up to the specified number of decimal places and also must not exceed 8 significant digits.
      `absSum` - Parameter showing the value of the surcharge or discount (depending on characters) as a sum. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant0Version1

    public FiscalResponse command49Variant0Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) ENTER A PRODUCT (SALE) Percentage Mark-up / discount
    Specified by:
      `command49Variant0Version1` in class `FiscalPrinterV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `Dept` - Department number. Integer from 1 to 60 inclusive. The sale is belongs to the tax group with which the department is associated at its programming.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded from FU to the specified number of decimal places and also should not exceed 8 significant digits.
      `UN` - Unit name. Optional text for unit of quantity up to 8 symbols, for example "kg".
      `perc` - Parameter showing the value of the surcharge or discount (depending on characters) as a percentage of current sales. Permissible values â€‹â€‹are from -99.00% to 99.00%. Accepted up to 2 decimal places.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant1Version1

    public FiscalResponse command49Variant1Version1​(java.lang.String L1, java.lang.String L2, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    31h (49) ENTER A PRODUCT (SALE) Mark-up / discount on value
    Specified by:
      `command49Variant1Version1` in class `FiscalPrinterV1`
    Parameters:
      `L1` - Text up to 22 bytes containing a line describing the sale
      `L2` - Text up to 22 bytes containing a second line describing the sale
      `Dept` - A byte containing the letter indicating the type of tax ('A', 'B', 'C', ...). There is a restriction depending on the Enabled_taxes parameter, which is set at setting the currency in command 83.
      `price` - Price up to 8 significant digits.
      `quan` - The quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product Price * Qwan is rounded off by FU
      `UN` - Unit name. Optional text for unit of quantity up to 8 * symbols, such as "kg".

      up to the specified number of decimal places and also must not exceed 8 significant digits.

      `absSum` - Parameter showing the value of the surcharge or discount (depending on characters) as a sum. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command50Variant0Version0

    public FiscalResponse command50Variant0Version0​(java.lang.String startDate, java.lang.String endDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    32h (50) TAX RATES PERFORMED DURING THE RESPECTIVE PERIOD
    Specified by:
      `command50Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `startDate` - Period start date - DDMMYY
      `endDate` - Period end date - DDMMYY
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant0Version0

    public FiscalResponse command51Variant0Version0​(java.lang.String print, java.lang.String display) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    33h (51) SUBTOTAL
    Specified by:
      `command51Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `print` - One byte: if it is '1', the subtotal will be printed.
      `display` - One byte: if it is '1', the subtotal will be displayed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant1Version0

    public FiscalResponse command51Variant1Version0​(java.lang.String print, java.lang.String display, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    33h (51) SUBTOTAL

    Percentage Mark-up / discount

    Specified by:
      `command51Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `print` - One byte: if it is '1', the subtotal will be printed.
      `display` - One byte: if it is '1', the subtotal will be displayed.
      `perc` - Optional parameter indicating the percentage value of the discount or mark-up on the sum accumulated until now.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant2Version0

    public FiscalResponse command51Variant2Version0​(java.lang.String print, java.lang.String display, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    33h (51) SUBTOTAL Mark-up or discount by amount
    Specified by:
      `command51Variant2Version0` in class `FiscalPrinterV1`
    Parameters:
      `print` - One byte: if it is '1', the subtotal will be printed.
      `display` - One byte: if it is '1', the subtotal will be displayed.
      `absSum` - Value of the mark-up or discount (depending on the sign), as an amount (up to 8 significant digits). A discount amount exceeding the value of the sale is not allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant0Version0

    public FiscalResponse command52Variant0Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) ENTER AND DISPLAY mark-up or discount by a percentage
    Specified by:
      `command52Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `L1` - String, up to 20 bytes, containing a line of text describing the sale
      `taxCd` - One byte containing the letter indicating the tax type ('A', 'B', 'C', ...). There is a restriction dependant on the Enabled_taxes parameter which is set when the currency is set using command 83.
      `price` - This is the price, with up to 8 significant digits.
      `quan` - Optional parameter indicating the product quantity. By default, it is 1.000. Length, up to 8 significant digits.
      `UN` - Name of the unit of measurement. Optional text for the unit of measurement for the quantity, up to 8 characters, for instance, "kg".
      `perc` - This is an optional parameter indicating the value of the mark-up or discount (depending on the sign), as a percentage of the current sale. The allowable values are between -99.00% and 99.00%.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant1Version0

    public FiscalResponse command52Variant1Version0​(java.lang.String L1, java.lang.String taxCd, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) ENTER AND DISPLAY

    mark-up or discount by a amount

    Specified by:
      `command52Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `L1` - String, up to 20 bytes, containing a line of text describing the sale
      `taxCd` - One byte containing the letter indicating the tax type ('A', 'B', 'C', ...). There is a restriction dependant on the Enabled_taxes parameter which is set when the currency is set using command 83.
      `price` - This is the price, with up to 8 significant digits.
      `quan` - Optional parameter indicating the product quantity. By default, it is 1.000. Length, up to 8 significant digits.
      `UN` - Name of the unit of measurement. Optional text for the unit of measurement for the quantity, up to 8 characters, for instance, "kg".
      `absSum` - Value of the mark-up or discount (depending on the sign), as an amount. A discount amount exceeding the value of the sale is not allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant0Version1

    public FiscalResponse command52Variant0Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) ENTER AND DISPLAY mark-up or discount by a percentage
    Specified by:
      `command52Variant0Version1` in class `FiscalPrinterV1`
    Parameters:
      `L1` - String, up to 20 bytes, containing a line of text describing the sale
      `Dept` - Department number. Integer between 1 and 1200 inclusive. The sale is assigned to the tax group associated with the department when it is programmed.
      `price` - This is the price, with up to 8 significant digits.
      `quan` - Optional parameter indicating the product quantity. By default, it is 1.000. Length, up to 8 significant digits.
      `UN` - Name of the unit of measurement. Optional text for the unit of measurement for the quantity, up to 8 characters, for instance, "kg".
      `perc` - This is an optional parameter indicating the value of the mark-up or discount (depending on the sign), as a percentage of the current sale. The allowable values are between -99.00% and 99.00%.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command52Variant1Version1

    public FiscalResponse command52Variant1Version1​(java.lang.String L1, java.lang.String Dept, java.lang.String price, java.lang.String quan, java.lang.String UN, java.lang.String absSum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    34h (52) ENTER AND DISPLAY mark-up or discount by a amount
    Specified by:
      `command52Variant1Version1` in class `FiscalPrinterV1`
    Parameters:
      `L1` - String, up to 20 bytes, containing a line of text describing the sale
      `Dept` - Department number. Integer between 1 and 1200 inclusive. The sale is assigned to the tax group associated with the department when it is programmed.
      `price` - This is the price, with up to 8 significant digits.
      `quan` - Optional parameter indicating the product quantity. By default, it is 1.000. Length, up to 8 significant digits.
      `UN` - Name of the unit of measurement. Optional text for the unit of measurement for the quantity, up to 8 characters, for instance, "kg".
      `absSum` - Value of the mark-up or discount (depending on the sign), as an amount. A discount amount exceeding the value of the sale is not allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command53Variant0Version0

    public FiscalResponse command53Variant0Version0​(java.lang.String L1, java.lang.String L2, java.lang.String paidMode, java.lang.String amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    35h (53) TOTAL CALCULATION
    Specified by:
      `command53Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `L1` - Text, up to 36 bytes, containing the first line
      `L2` - Text, up to 36 bytes, containing the second line
      `paidMode` - 'P' - In Cash (default) 'N' - Credit card 'C' - Check 'D' - Card 'I' - Programmable payment type 1 'J' - Programmable payment type 2 'K' - Programmable payment type 3 'L' - Programmable payment type 4 'i' - Programmable payment type 1 'j' - Programmable payment type 2 'k' - Programmable payment type 3 'l' - Programmable payment type 4 'm' - Coupons 'n' - External coupons 'o' - Packing 'p' - Internal service 'q' - Damages 'r' - Bank transfers 's' - Check 'E' - Cash payment (alternative currency)
      `amount` - The amount payable (up to 10 significant digits).
    Returns:
      - PaidCode One byte: command result. 'F' Error. 'E' The calculated subtotal is negative. No payment is made and Amount will contain the negative subtotal. 'D' If the amount paid is less than the amount on the receipt. The remaining amount to be paid is returned to Amount. 'R' If the amount paid is more than the sum on the receipt. A "CHANGE" message will be printed and the change is returned to Amount. 'I' The sum under any tax group is negative, causing an error. The current subtotal is returned to Amount.

      Amount_Out - The amount payable (up to 10 significant digits).

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command54Variant0Version0

    public FiscalResponse command54Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    36h (54) PRINT FREE FISCAL TEXT
    Specified by:
      `command54Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `text` - Text Free text to print. The '#' character is printed at the start and the end of the line. The text may be with any length, but only the characters fitting on the line are used (without raising a truncation error).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command54Variant1Version0

    public FiscalResponse command54Variant1Version0​(java.lang.String Font, java.lang.String Flags, java.lang.String Text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    36h (54) PRINT FREE FISCAL TEXT
    Specified by:
      `command54Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `Font` - Integer between 0 and 3: 0 32 dots (4 mm) height, higher letters 1 32 dots (4 mm) height, normal letters 2 24 dots (3 mm) height 3 16 dots (2 mm) height
      `Flags` - B Bold (strong) H High (double height) I Italic (oblique)
      `Text` - Free text to print. The '#' character is printed at the start and the end of the line. The text may be with any length, but only the characters fitting on the line are used (without raising a truncation error).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command56Variant0Version0

    public FiscalResponse command56Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    38h (56) CLOSING A FISCAL RECEIPT

    Specified by:
      `command56Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - Allreceipt - All receipts issued since the last closing time until now. FiscReceipt - All fiscal receipts issued since the last closing time until now.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command57Variant0Version0

    public FiscalResponse command57Variant0Version0​(java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    39h (57) PRINT OF CUSTOMER INFORMATION
    Specified by:
      `command57Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Bulstat` - UIC number of the buyer. Between 9 and 14 characters.
      `seller` - Tab (09H). Separator between parameters.
      `receiver` - Name of the seller. Up to 36 characters.
      `client` - Recipient's name. Up to 36 characters.
      `taxNo` - VAT number of the buyer. Between 10 and 14 characters.
      `address` - Address of the buyer. Up to two lines of text of a maximum of 36 characters, separated by LF (0AH).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command57Variant1Version0

    public FiscalResponse command57Variant1Version0​(java.lang.String bulstatType, java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    39h (57) PRINT OF CUSTOMER INFORMATION
    Specified by:
      `command57Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `Bulstat` - If it is preceded by the '#' character, the data is considered as a PIN or a symbol '*' - personal number or symbol ' ^ '- business number.
      `seller` - Name of the seller. Up to 36 characters.
      `receiver` - Name of the recipient. Up to 36 characters.
      `client` - Buyer's name. Up to 36 characters.
      `taxNo` - VAT number of the buyer. Between 10 and 14 characters.
      `address` - Address of the buyer. Up to two lines of text of a maximum of 36 characters, separated by LF (0AH).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command57Variant2Version0

    public FiscalResponse command57Variant2Version0​(java.lang.String bulstatType, java.lang.String Bulstat, java.lang.String seller, java.lang.String receiver, java.lang.String client, java.lang.String taxNo, java.lang.String address, java.lang.String accPer) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    39h (57) PRINT OF CUSTOMER INFORMATION Accountable Person
    Specified by:
      `command57Variant2Version0` in class `FiscalPrinterV1`
    Parameters:
      `Bulstat` - If it is preceded by the '#' character, the data is considered as a PIN or a symbol '*' - personal number or symbol ' ^ '- business number.
      `seller` - Name of the seller. Up to 36 characters.
      `receiver` - Name of the recipient. Up to 36 characters.
      `client` - Buyer's name. Up to 36 characters.
      `taxNo` - VAT number of the buyer. Between 10 and 14 characters.
      `address` - Address of the buyer. Up to two lines of text of a maximum of 36 characters, separated by LF (0AH).
      `accPer` - Accountable Person
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command58Variant0Version0

    public FiscalResponse command58Variant0Version0​(java.lang.String display, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String UN, java.lang.String perc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Ah (58) REGISTRATION (SALE) OF ITEM (PLU) Percentage mark-up or discount
    Specified by:
      `command58Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `display` - - If the string is empty, the sale is not shown on the customer display. If the length of the item name is more than 20, the characters after the 20th are cut off.
      `plu` - This is the item number. Integer from 1 to 999999999 (up to 9 digits).
      `dept` - Department number. Integer from 1 to 60 inclusive. If this parameter is present, then the separating tabs must be present.
      `quan` - Parameter specifying the quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product (Unit price) * Qwan is rounded from FU to the specified number of decimal places and also should not exceed 8 significant digits.
      `UN` - Unit name. Optional text for unit of quantity up to 8 symbols, for example "kg".
      `perc` - Parameter indicating the value of the surcharge or discount (depending on the sign) in percentages on the current sale. Permissible values â€‹â€‹are from -99.00% to 99.00%. Up to 2 decimal places are accepted.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command58Variant0Version1

    public FiscalResponse command58Variant0Version1​(java.lang.String D, java.lang.String plu, java.lang.String dept, java.lang.String quan, java.lang.String UN, java.lang.String abs) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Ah (58) REGISTRATION (SALE) OF ITEM Mark-up or discount by value
    Specified by:
      `command58Variant0Version1` in class `FiscalPrinterV1`
    Parameters:
      `plu` - This is the item number. Integer from 1 to 999999999 (up to 9 digits).
      `dept` - Department number. Integer from 1 to 60 inclusive. If this parameter is present, then the separating tabs must be present.
      `quan` - Parameter specifying the quantity of the goods. The default is 1,000. Length up to 8 significant digits (not more than 3 after the decimal point). The product (Unit price) * Qwan is rounded from FU to the specified number of decimal places and also should not exceed 8 significant digits.
      `abs` - Parameter indicating the value of the surcharge or discount (depending on the sign) as an amount. No discount with a value greater than the value of the sale is allowed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command60Variant0Version0

    public FiscalResponse command60Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Ch (60) CANCEL (TERMINATE) A FISCAL RECEIPT
    Specified by:
      `command60Variant0Version0` in class `FiscalPrinterV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command61Variant0Version0

    public FiscalResponse command61Variant0Version0​(java.lang.String date, java.lang.String time) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Dh (61) SET THE DATE AND TIME A date before the last fiscal memory record date cannot be set. The device is intended to operate until the year 2099 inclusive. After a memory RESET, the command must be executed to continue normal operation, whereby a RESET record is made in the fiscal memory. It is not possible to set the date and time before those of the last printed document stored in the EJ. This is to ensure correct searching for documents in the EJ by date and time for printing or downloading over the serial interface as text
    Specified by:
      `command61Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `date` - DD-MM-YY
      `time` - HH:MM[:SS]
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command61Variant1Version0

    public FiscalResponse command61Variant1Version0​(java.lang.String dateTime) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Dh (61) SET THE DATE AND TIME

    A date before the last fiscal memory record date cannot be set. The device is intended to operate until the year 2099 inclusive. After a memory RESET, the command must be executed to continue normal operation, whereby a RESET record is made in the fiscal memory. It is not possible to set the date and time before those of the last printed document stored in the EJ. This is to ensure correct searching for documents in the EJ by date and time for printing or downloading over the serial interface as text

    Specified by:
      `command61Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `dateTime` - DD-MM-YY HH:MM[:SS]
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command62Variant0Version0

    public FiscalResponse command62Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Eh (62) READ THE DATE AND TIME
    Specified by:
      `command62Variant0Version0` in class `FiscalPrinterV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command63Variant0Version0

    public FiscalResponse command63Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    3Fh (63) DISPLAY THE DATE AND TIME
    Specified by:
      `command63Variant0Version0` in class `FiscalPrinterV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command64Variant0Version0

    public FiscalResponse command64Variant0Version0​(java.lang.String Option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    40h (64) INFORMATION ON THE LAST FISCAL RECORD
    Specified by:
      `command64Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Option` - - '*' If available, the time of the daily report + is returned No parameter - Amounts by sales tax groups. '0' - Amounts by sales tax groups. '1' - Amounts by tax groups from reversal transactions.

      report.

    Returns:
      - ErrCode Error code: 'P' The command is successful. Data follows. 'F' The last entry is not read. Closure This is the number of the last fiscal record - 4 bytes. TaxX Amount of turnover by tax group X, depending on the input parameter. 12 bytes with sign. ClosureDate The date of the fiscal record - 6 bytes / DDMMYY /.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant0Version0

    public FiscalResponse command65Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    41h (65) INFORMATION ON THE SUMS UNDER TAX GROUPS FOR THE DAY
    Specified by:
      `command65Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - Specifies what information to return: '0' - Total turnover. '1' - Accumulated VAT. If the parameter is missing, the default is '0'
    Returns:
      - Option = 0 TaxA, TaxB, TaxC, TaxD, TaxE, TaxF, TaxG, TaxH * The amounts by tax groups (Total turnover) from the last end of the day to the moment of * receive the command. * Option = 1 TaxA, TaxB, TaxC, TaxD, TaxE, TaxF, TaxG, TaxH * The amounts by tax groups (Accumulated VAT) from the last end of the day until now are refunded * on receiving the command.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command66Variant0Version0

    public FiscalResponse command66Variant0Version0​(java.lang.String start, java.lang.String end) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    42h (66) SET ALLOWABLE INVOICE NUMBER RANGE
    Specified by:
      `command66Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `start` - Sets the range start value. Integer up to 10 digits.
      `end` - Sets the range end value. Integer up to 10 digits.
    Returns:
      - start -Current start value. Integer up to 10 digits. end -Current end value. Integer up to 10 digits. current - The current invoice counter value. 10-digit integer.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command68Variant0Version0

    public FiscalResponse command68Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    44h (68) NUMBER OF AVAILABLE FIELDS IN THE FISCAL MEMORY
    Specified by:
      `command68Variant0Version0` in class `FiscalPrinterV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command69Variant0Version0

    public FiscalResponse command69Variant0Version0​(java.lang.String reportType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    45h (69) DAILY FINANCIAL REPORT clearing of accumulated data by operator
    Specified by:
      `command69Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `reportType` - '0' Prints a Z-report. The printout ends with the "FISCAL RECEIPT" text. '2' A daily financial report without reset is run (i.e., no information is recorded in the fiscal memory and the registers are not reset). The printout ends with the "SERVICE RECEIPT" logo.
    Returns:
      - Closure - The fiscal record number: 4 bytes. FM_Total - The sum of all non-VAT sales: 12 bytes with a sign TotX - The sums under each tax group 'A', 'B', 'C', â€¦ : 12 bytes with a sign.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command70Variant0Version0

    public FiscalResponse command70Variant0Version0​(java.lang.String amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    46h (70) SERVICE MONEY DEPOSIT AND WITHDRAWAL
    Specified by:
      `command70Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `amount` - The amount to be registered (up to 10 significant digits). Depending on the sign of the number, it is interpreted as a deposit or withdrawal.
    Returns:
      ExitCode : - 'P' The request is executed. If the requested amount is not zero, the printer prints a service receipt to register the transaction. - 'F' The request is denied. This happens, if: CashSum - Available cash. The amount is increased both with this command and with each cash payment. ServIn - The sum of all "Service Deposit" commands. ServOut - The sum of all "Service Withdrawal" commands.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command71Variant0Version0

    public FiscalResponse command71Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    47h (71) PRINT DIAGNOSTIC INFORMATION
    Specified by:
      `command71Variant0Version0` in class `FiscalPrinterV1`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command73Variant0Version0

    public FiscalResponse command73Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String Start, java.lang.String End) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    49h (73) FULL FISCAL MEMORY REPORT BY BLOCK NUMBER
    Specified by:
      `command73Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `SHA1` - Optional argument: one byte with a value of '#'. If present, for each Z-report, prints also the checksum using the SHA-1 algorithm.
      `SkipZ` - Optional argument: one byte with a value of '*'. If present, for each Z-report, prints only the tax rates with non-zero accumulated sums for the day. Such report is non-standard and can be used only as an internal reference at the location!
      `Start` - Start fiscal block number. 4 bytes.
      `End` - End fiscal block number. 4 bytes.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant0Version0

    public FiscalResponse command74Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) OBTAIN THE PRINTER STATUS
    Specified by:
      `command74Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - One byte with the following meanings: W First, waits for the printer to finish printing everything in the print buffer. X Does not wait for the printer, but responds immediately. L Returns the number of lines remaining to be printed. P Returns printer hardware information. R Returns data on the customer documents sent to the NRA server. D Returns cash drawer status (0 - closed drawer, 1 - open drawer) for models that support it (FP-2000 or FP-700) if supported by the connected drawer. B Returns the status of open shift lock (0 - not blocked, 1 - blocked).
    Returns:
      - Sx - Status byte N.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant1Version0

    public FiscalResponse command74Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) OBTAIN THE PRINTER STATUS

    Specified by:
      `command74Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - Nlines - Number of pending lines in the print buffer. A value of 0 means that there are no pending print data.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant2Version0

    public FiscalResponse command74Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) OBTAIN THE PRINTER STATUS
    Specified by:
      `command74Variant2Version0` in class `FiscalPrinterV1`
    Returns:
      - HdwInfo - Returns printer operation statistics since the manufacture date until now. The data are in the following format: Len - Length of the printed paper in millimetres. Docs - Number of printed documents. Cuts - Number of paper cuts. PwOns - Number of times the printer was powered-on. MdRst - Number of modem restarts. Not currently supported.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant3Version0

    public FiscalResponse command74Variant3Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ah (74) OBTAIN THE PRINTER STATUS
    Specified by:
      `command74Variant3Version0` in class `FiscalPrinterV1`
    Returns:
      InfoReciepts Returns data on the sent and unsent customer receipts

      Lastprintdoc Number of the last printed document. Nlastsentdoc Number of the last successfully sent document. Dtlastsentdoc Date and time of the last successfully sent document. Minfromlastsuccesssent Minutes since the last successfully sent document. Nfirstnotsentdoc Number of the first unsent document. Dtfirstnotsentdoc Date and time of the first unsent document. Minfromfirstnotsuccesssent Minutes since the first unsent document.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command75Variant0Version0

    public FiscalResponse command75Variant0Version0​(java.lang.String Restore) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Bh (75) FORCE SUPPRESSED PRINTING
    Specified by:
      `command75Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Restore` - Restore One byte with the following possible values: 0 After the end of printing, printing is reenabledâ€”next data will be printed immediately. 1 After the print buffer is cleared, printing remains suppressed until the end of the receipt.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command76Variant0Version0

    public FiscalResponse command76Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Ch (76) FISCAL TRANSACTION STATUS
    Specified by:
      `command76Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - Option = 'T'. If this parameter is set, the command will return the information on the current status of the bill payable by the customer until now.
    Returns:
      - Open - One byte which is '1', if a fiscal or service receipt is open (the exact type is indicated by the status bits), and '0', if no receipt is open. Items - The number of sales entered on the current or last fiscal receipt. 4 bytes. Amount - The amount on the last fiscal receipt: 9 bytes with a sign. Tender - The amount paid on the current or last receipt. 9 bytes with a sign.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command79Variant0Version0

    public FiscalResponse command79Variant0Version0​(java.lang.String start, java.lang.String end) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    4Fh (79) SHORT FISCAL MEMORY REPORT FROM DATE TO DATE
    Specified by:
      `command79Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `start` - Start date: 6 bytes (DDMMYY)
      `end` - End date: 6 bytes (DDMMYY)
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command80Variant0Version0

    public FiscalResponse command80Variant0Version0​(java.lang.String hz, java.lang.String mSec) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    50H (80) BEEP (TONE)
    Specified by:
      `command80Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `hz` -
      `mSec` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command80Variant1Version0

    public FiscalResponse command80Variant1Version0​(java.lang.String SoundData) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    50H (80) BEEP (TONE)
    Specified by:
      `command80Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `SoundData` - The command is used to emit a sequence of tones with set frequencies and durations. Without data input, a beep with a frequency of 2 kHz and a duration of 300 ms is emitted. If the data input is of the following type: [Hz],[mSec] where Hz and mSec are integers, then a tone with a frequency of Hz Hertz (between 100 and 5000) and a duration of mSec milliseconds (between 50 and 2000) is emitted. In the other cases, the data are similar to a musical notation and can have any length (not exceeding the protocol limit of 218 bytes). The first invalid character interrupts the command. The allowed subcommands in the data are: Note: One Latin capital letter with a value between 'A' and 'G'. 'C' Do 'D' Re 'E' Mi 'F' Fa 'G' Sol 'A' La 'B' Ti If the note is immediately followed by the '#' character, then it is raised by one semitone (sharp). If the note is immediately followed by the AND character, then it is lowered by one semitone (flat). Rest: The space character (ASCII 20h). After a note or a rest, there can be one or more bytes specifying the duration. The valid characters are between '0' and '5', having the following meanings: '0' Base duration '1' Base duration * 2 '2' Base duration * 4 '3' Base duration * 8 '4' Base duration * 16 '5' Base duration * 32 If there are multiple sequential durations, they are added together. ï‚· Play on a higher scale: the '+' character. ï‚· Play on a lower scale: the '-' character. ï‚· Set the tempo: The '^' character followed by a single digit. The digit sets the note and rest durations as a percentage of the base duration. Allowed value: '1' 200% '2' 175% '3' 140% '4' 120% '5' 100% '6' 80% '7' 60% '8' 50% '9' 40% Return to scale 1 (default). The '@' character. The 'La' tone in this scale is 440 Hz. _ Fiscal printer programming interface Version 2.00BG DATECS FP-800 / FP-2000 / FP-650 / SK1-21F / SK1-31F/ FMP-10 / FP-700 The sent sequence is played on the background and the printer can continue executing commands during playback.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command81Variant1Version0

    public FiscalResponse command81Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    51H (81) OBTAIN THE SUPPLY VOLTAGE AND TEMPERATURE
    Specified by:
      `command81Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - Vh The supply voltage in volts. Temp The printing head temperature in degrees
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command83Variant0Version0

    public FiscalResponse command83Variant0Version0​(java.lang.String multiplier, java.lang.String decimals, java.lang.String currency, java.lang.String enabledT, java.lang.String taxA, java.lang.String taxB, java.lang.String taxC, java.lang.String taxD, java.lang.String taxE, java.lang.String taxF, java.lang.String taxG, java.lang.String taxH) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    53h (83) SET THE DECIMAL DIGITS, CURRENCY AND TAX RATES
    Specified by:
      `command83Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `multiplier` - Multiplier - between 0 and 3 and shows the power of 10 before multiply by the input or output number. It is currently disabled and is not used.
      `decimals` - This is a byte with a value between 0 and 2 and shows the location where to put the decimal point.
      `currency` - The name of the currency. Up to 3 bytes.
      `enabledT` - 8 bytes with possible value '0' or '1', determining whether the respective tax group is disabled ('0') or * enabled ('1').
      `taxA` - The value of tax rates.
      `taxB` -
      `taxC` -
      `taxD` -
      `taxE` -
      `taxF` -
      `taxG` -
      `taxH` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command83Variant1Version0

    public FiscalResponse command83Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    53h (83) READING OF DECIMALS, CURRENCY AND TAX RATES
    Specified by:
      `command83Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      -

      Multiplier - Multiplier: between 0 and 3, specifying the power of 10 before being multiplied by the input or output number. Currently deactivated and not used. Decimals - This is one byte with a value between 0 and 2 specifying the decimal point position. Currency_name - The currency name. Up to 6 bytes. EnabledT - 8 bytes with possible values of '0' or '1' specifying whether the respective tax group is disabled ('0') or enabled ('1'). TaxX The values of the tax rates.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command84Variant0Version0

    public FiscalResponse command84Variant0Version0​(java.lang.String Type, java.lang.String Align, java.lang.String AllowN, java.lang.String AllowD, java.lang.String Data) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    54H (84) BARCODE PRINT
    Specified by:
      `command84Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Type` - e Barcode type. One byte with the following allowed values: '1' EAN8. The data contain only digits and are 7 or 8 bytes long. The checksum is calculated by the printer, if it is not submitted, if it is submitted and is wrong command is rejected. '2' EAN13. The data contain only digits and are 12 or 13 bytes long. The checksum is calculated by the printer, if it is not submitted, if it is submitted and is wrong command is rejected. '3' Code 128. The data are characters with ASCII codes between 32 and 127. Their length is between 22 and 42 characters (depends on the contentsâ€”the maximum length is achieved when all characters are digits). The checksum is calculated by the printer. When printing on narrow paper, the data length is obviously smaller. '4' ITF (Interleaved 2 of 5). The data contain only digits. '5' ITF (Interleaved 2 of 5). The data contain only digits. The printer automatically generates and prints a checksum. 'D' Two-dimensional barcode Data Matrix. The data are any printable characters (with length up to 140). 'Q' Two-dimensional barcode QR Code. The data are any printable characters (with length up to 140). 'P' Two-dimensional barcode PDF417. The data are any printable characters (with length up to 140).
      `Align` - One byte - 'L', 'R', or 'C' - left and right aligned or centered, respectively.
      `AllowD` - Only valid for 2D barcodes. If the string is empty, the barcode data is not printed.
      `AllowN` - Optional parameter - one character with value '*'. If there are, barcodes Code 128 and ITF if necessary (longer input data) will be printed in size on the thin line only one point. Note that the barcode printed in this way does not meets the standards, but most readers will still read it. The maximum length of input data doubles. On the other barcodes the parameter has no effect.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command85Variant0Version0

    public FiscalResponse command85Variant0Version0​(java.lang.String option, java.lang.String name) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    55H (85) SET THE ADDITIONAL PAYMENT NAMES
    Specified by:
      `command85Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - 'I' Additional payment 1. 'J' Additional payment 2. 'K' Additional payment 3. 'L' Additional payment 4. 'i' Additional payment 1. Identical to 'I'. 'j' Additional payment 2. Identical to 'J'. 'k' Additional payment 3. Identical to 'K'. 'l' Additional payment 4. Identical to 'L'. 'm' Additional payment 5. 'n' Additional payment 6. 'o' Additional payment 7. 'p' Additional payment 8. 'q' Additional payment 9. 'r' Additional payment 10. 's' Additional payment 11.
      `name` - Name of the respective payment type (up to 24 characters).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command85Variant1Version0

    public FiscalResponse command85Variant1Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    55H (85) READ THE ADDITIONAL PAYMENT NAMES
    Specified by:
      `command85Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - 'I' Additional payment 1. 'J' Additional payment 2. 'K' Additional payment 3. 'L' Additional payment 4. 'i' Additional payment 1. Identical to 'I'. 'j' Additional payment 2. Identical to 'J'. 'k' Additional payment 3. Identical to 'K'. 'l' Additional payment 4. Identical to 'L'. 'm' Additional payment 5. 'n' Additional payment 6. 'o' Additional payment 7. 'p' Additional payment 8. 'q' Additional payment 9. 'r' Additional payment 10. 's' Additional payment 11.
    Returns:
      - Name - returns the current name .
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command86Variant0Version0

    public FiscalResponse command86Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    56H (86) READ THE DATE OF THE LAST RECORD IN THE FISCAL MEMORY
    Specified by:
      `command86Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - The date (or date and time) of the last (latest) record in the fiscal memory, in the following format: DD-MM-YYYY
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command86Variant1Version0

    public FiscalResponse command86Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    56H (86) READ THE DATE OF THE LAST RECORD IN THE FISCAL MEMORY
    Specified by:
      `command86Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - The date (or date and time) of the last (latest) record in the fiscal memory, in the following format:

      DD,MM,YYYY,hh,mm,ss

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command87Variant0Version0

    public FiscalResponse command87Variant0Version0​(java.lang.String dept, java.lang.String taxGr, java.lang.String line1, java.lang.String line2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    57H (87) PROGRAM A DEPARTMENT NAME The command can be executed only if no fiscal receipts for the department have been issued after the last Z-report. With a new printer or after a RAM reset, the department names are empty. The programmed name is printed on the extended daily fi
    Specified by:
      `command87Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `dept` - Department number. Integer between 1 and 1200.
      `taxGr` - Tax group associated with the department.
      `line1` - Department name or descriptive text. Up to 28 characters.
      `line2` - Department name or descriptive textâ€”second line. Optional parameter: up to 34 characters.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command88Variant0Version0

    public FiscalResponse command88Variant0Version0​(java.lang.String dept) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    58H (88) OBTAIN DATA ON THE ACCUMULATED SUMS FOR A DEPARTMENT
    Specified by:
      `command88Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `dept` - - Department number. Integer between 1 and 1200. Value 0 returns data on the sales made without department specified. In this case, the tax group is missing.
    Returns:
      - ExitCode - One byte with the following possible values: 'P' The department is programmed. Followed by the department data listed below. 'F' The department is not programmed. No data on it exist. TaxGr - The tax group of the department. RecSales - Number of sales for the department in the receipt. RecSum - Accumulated sum for the current or last fiscal receipt for the respective department. Floating-point number with two decimal digits. TotSales - Number of sales for the department, for the day. TotSum -Accumulated sum for the day, for the respective department. Floating-point number with two decimal digits. Line1 - Department name or descriptive text. Line2 - Department name or descriptive textâ€”second line.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command90Variant0Version0

    public FiscalResponse command90Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Ah (90) READING DIAGNOSTIC INFORMATION
    Specified by:
      `command90Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - At value '1' - a checksum is calculated the code memory (firmware), otherwise returns 'FFFF '.
    Returns:
      - Name - Name of FD. FwRev - Software version. 4 bytes. FwDate - The date of the DDMmmYY software. 7 bytes. FwTime - Time of HHMM software. 4 bytes. Chk - EPROM checksum. 4 bytes string in hexadecimal. For example, if the checksum is 214Ah, it will be transmitted 32h, 31h, 34h, 41h. Sw - Not supported by FI. Ser - Individual device number - 8 bytes. FM - Fiscal module number - 8 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command92Variant0Version0

    public FiscalResponse command92Variant0Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Ch (92) PRINT A DIVIDER LINE
    Specified by:
      `command92Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `type` - '1' Fill with the symbol '-'. '2' Fill in sequentially with the symbols '-' and ''. '3' Fill with the symbol '='. '4' Fill with the double-width symbol '*'
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command92Variant1Version0

    public FiscalResponse command92Variant1Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Ch (92) SEPARATION ON A DISTRIBUTION LINE The command is supported only in service receipts!
    Specified by:
      `command92Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `type` - 0 to 3 (bit mask) 0 - Unconditionally add the inscription "no payment due!" With triple height. 1 - adds the inscription "on this receipt". 2 - adds a frame of the double width symbol '*' at the top and bottom.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command93Variant1Version0

    public FiscalResponse command93Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Dh (93) OBTAIN INFORMATION ON THE DISCOUNTS AND MARK-UPS FOR THE DAY
    Specified by:
      `command93Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - CntD Number of discounts after the last Z-report. SumD Sum of discounts after the last Z-report. CntM Number of mark-ups after the last Z-report. SumM Sum of mark-ups after the last Z-report.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command94Variant0Version0

    public FiscalResponse command94Variant0Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate, java.lang.String endDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Eh (94) FULL FISCAL MEMORY REPORT BY FISCAL RECORD DATE
    Specified by:
      `command94Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `SHA1` - Optional argument: one byte with a value of '#'. If present, for each Z-report, prints also the checksum using the SHA-1 algorithm.
      `startDate` - The start fiscal record date. 6 bytes (DDMMYY).
      `endDate` - The end fiscal record date. 6 bytes (DDMMYY).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command94Variant1Version0

    public FiscalResponse command94Variant1Version0​(java.lang.String SHA1, java.lang.String SkipZ, java.lang.String startDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Eh (94) FULL FP REPORT BY DATE MONTHLY OR ANNUALLY
    Specified by:
      `command94Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `startDate` - The start date of the fiscal record. Month - 4 bytes (MMYY) for monthly report. Year - 2 bytes (YY) for annual report.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command95Variant0Version0

    public FiscalResponse command95Variant0Version0​(java.lang.String first, java.lang.String last) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    5Fh (95) SHORT FISCAL MEMORY REPORT FOR A PERIOD
    Specified by:
      `command95Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `first` - Start fiscal record number
      `last` - End number of fiscal record.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command97Variant0Version0

    public FiscalResponse command97Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    61h (97) READ THE SET TAX RATES
    Specified by:
      `command97Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - TaxA Tax rate A TaxB Tax rate B TaxC Tax rate C TaxD Tax rate D TaxE Tax rate E TaxF Tax rate F TaxG Tax rate G TaxH Tax rate H
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command99Variant0Version0

    public FiscalResponse command99Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    63h (99) READ THE UIC
    Specified by:
      `command99Variant0Version0` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command100Variant0Version0

    public FiscalResponse command100Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    64h (100) SHOW TEXT ON THE DISPLAY
    Specified by:
      `command100Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `text` - Text Text, up to 40 characters, sent to the display. If ASCII characters below 20h (control sequences) need to be sent, they are increased by 40h and are preceded by 10h (DLE). For example: to send 1Bh,4Bh,00h, it must be entered as 10h,5Bh,4Bh,10h,40h in the data field.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command101Variant0Version0

    public FiscalResponse command101Variant0Version0​(java.lang.String operatorCode, java.lang.String oldPassword, java.lang.String newPassword) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    65h (101) SET AN OPERATOR PASSWORD Sets one of the sixteen operator passwords. The password will be requested when opening a fiscal receipt. After three unsuccessful attempts to set a password, the printer is locked and needs to be powered off and then back on to continue to operate. After initialisation or RAM reset, all passwords are "0000".
    Specified by:
      `command101Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `operatorCode` - Operator code. Between 1 and 16.
      `oldPassword` - Old password (between 4 and 8 digits).
      `newPassword` - New password (between 4 and 8 digits).

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command102Variant0Version0

    public FiscalResponse command102Variant0Version0​(java.lang.String operatorCode, java.lang.String operatorPass, java.lang.String operatorName) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    66h (102) SET AN OPERATOR NAME
    Specified by:
      `command102Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `operatorCode` - Operator code. Between 1 and 16.
      `operatorPass` - Password (between 4 and 8 digits).
      `operatorName` - Operator name (up to 24 characters).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command103Variant0Version0

    public FiscalResponse command103Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    67h (103) CURRENT RECEIPT INFORMATION
    Specified by:
      `command103Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      -

      CanVd: Is a return possible (sale with a negative sign) [0/1] TaxA: Accumulated sum under tax group A TaxB: Accumulated sum under tax group B TaxC: Accumulated sum under tax group C TaxD: Accumulated sum under tax group D TaxE: Accumulated sum under tax group E TaxF: Accumulated sum under tax group F TaxG: Accumulated sum under tax group G TaxH: Accumulated sum under tax group H Inv: Is an extended customer receipt open. InvNmb: Number of the next invoice (10 digits).

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command105Variant0Version0

    public FiscalResponse command105Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    68h (105) OPERATOR REPORT
    Specified by:
      `command105Variant0Version0` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command106Variant0Version0

    public FiscalResponse command106Variant0Version0​(java.lang.String mSec) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Ah (106) OPEN THE DRAWER
    Specified by:
      `command106Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `mSec` - Pulse length in milliseconds (5-100)
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant0Version0

    public FiscalResponse command107Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINE AND READ PLUs

    Article information

    Specified by:
      `command107Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - Total - Total number of programmable PLUs (3000 for this printer). Progr - Number of programmed PLUs. Len - Maximum PLU name length.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant1Version0

    public FiscalResponse command107Variant1Version0​(java.lang.String taxGr, java.lang.String PLU, java.lang.String group, java.lang.String price, java.lang.String replaceQty, java.lang.String quantity, java.lang.String name) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLUs) Program a PLU.
    Specified by:
      `command107Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `taxGr` - Tax group ('A', 'B', 'C', 'D' ...)
      `PLU` - PLU code (between 1 and 999999999)
      `group` - Product group (between 1 and 99)
      `price` - Unit price. Up to 8 significant digits.
      `replaceQty` - Optional parameter - one byte with value 'A'. Changes the value of the next parameter (Quantity).
      `quantity` - Number with up to 3 decimal places - the available quantity for the given one article. FD does not maintain quantity and returns 0.000
      `name` - PLU name. Up to 36 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant2Version0

    public FiscalResponse command107Variant2Version0​(java.lang.String PLU, java.lang.String quantity) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLUs) Change the available quantity for an item.
    Specified by:
      `command107Variant2Version0` in class `FiscalPrinterV1`
    Parameters:
      `PLU` -
      `quantity` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant3Version0

    public FiscalResponse command107Variant3Version0​(java.lang.String option, java.lang.String PLU, java.lang.String toPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLUs) Delete an item.
    Specified by:
      `command107Variant3Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - 'A' All items with non-zero accumulated amounts are deleted.
      `PLU` - Deletes the item with the specified number if there are no accumulated amounts.
      `toPLU` - Delete items next to instructions.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant4Version0

    public FiscalResponse command107Variant4Version0​(java.lang.String PLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Read item data.
    Specified by:
      `command107Variant4Version0` in class `FiscalPrinterV1`
    Parameters:
      `PLU` - Article number. Between 1 and 999999999.
    Returns:
      - Result P, F One byte 'F' is returned if an item is not found. PLU Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Stock Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FU. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FU does not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant5Version0

    public FiscalResponse command107Variant5Version0​(java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLUs) Return data for the first programmed item PLU found.
    Specified by:
      `command107Variant5Version0` in class `FiscalPrinterV1`
    Parameters:
      `startPLU` - Article number. Between 1 and 999999999.
    Returns:
      - Result P, F - One byte 'F' is returned if an item is not found.

      PLU Item number. Between 1 and 999999999. TaxGr Tax Group. One byte. Grp Stock Group. From 1 to 9. SPrice Unit price. Floating number with decimal places current for FU. Total Accumulated amount for the given item. Sold Sold quantity. Floating number with 3 decimal places. Avail Quantity available. FU does not maintain quantity and returns 0.000 Name Name of the item. Up to 22 bytes.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant6Version0

    public FiscalResponse command107Variant6Version0​(java.lang.String lastPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES (PLUs) Return the data for the last found programmed item.
    Specified by:
      `command107Variant6Version0` in class `FiscalPrinterV1`
    Parameters:
      `lastPLU` - Article number. Between 1 and 999999999.
    Returns:
      - Result P, F - One byte 'F' is returned if an item is not found. PLU Item number. Between 1 and 999999999. TaxGr Tax Group. One byte. Grp Stock Group. From 1 to 9. SPrice Unit price. Floating number with decimal places current for FU. Total Accumulated amount for the given item. Sold Sold quantity. Floating number with 3 decimal places. Avail Quantity available. FU does not maintain quantity and returns 0.000 Name Name of the item. Up to 22 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant7Version0

    public FiscalResponse command107Variant7Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Return the data for the next found programmed item
    Specified by:
      `command107Variant7Version0` in class `FiscalPrinterV1`
    Returns:
      - Result - P, F One byte 'F' is returned if an item is not found. PLU - Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Stock Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FU. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FU does not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant8Version0

    public FiscalResponse command107Variant8Version0​(java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Return the data for the first found item with non-zero sales
    Specified by:
      `command107Variant8Version0` in class `FiscalPrinterV1`
    Parameters:
      `startPLU` - Article number. Between 1 and 999999999. If the PLU parameter is set, then the search starts from it in ascending direction, otherwise start from 1.
    Returns:
      - Result P, F One byte 'F' is returned if an item is not found. PLU - Item number. Between 1 and 999999999. TaxGr - Tax Group. One byte. Grp - Stock Group. From 1 to 9. SPrice - Unit price. Floating number with decimal places current for FU. Total - Accumulated amount for the given item. Sold - Sold quantity. Floating number with 3 decimal places. Avail - Quantity available. FU does not maintain quantity and returns 0.000 Name - Name of the item. Up to 22 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant9Version0

    public FiscalResponse command107Variant9Version0​(java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Return data for the last found item non-zero sales.
    Specified by:
      `command107Variant9Version0` in class `FiscalPrinterV1`
    Returns:
      _ Result P, F One byte 'F' is returned if an item is not found. PLU Item number. Between 1 and 999999999. TaxGr Tax Group. One byte. Grp Stock Group. From 1 to 9. SPrice Unit price. Floating number with decimal places current for FU. Total Accumulated amount for the given item. Sold Sold quantity. Floating number with 3 decimal places. Avail Quantity available. FU does not maintain quantity and returns 0.000 Name Name of the item. Up to 22 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant10Version0

    public FiscalResponse command107Variant10Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Return data for the next found item non-zero sales.
    Specified by:
      `command107Variant10Version0` in class `FiscalPrinterV1`
    Returns:
      _ Result P, F One byte 'F' is returned if an item is not found. PLU Item number. Between 1 and 999999999. TaxGr Tax Group. One byte. Grp Stock Group. From 1 to 9. SPrice Unit price. Floating number with decimal places current for FU. Total Accumulated amount for the given item. Sold Sold quantity. Floating number with 3 decimal places. Avail Quantity available. FU does not maintain quantity and returns 0.000 Name Name of the item. Up to 22 bytes.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant11Version0

    public FiscalResponse command107Variant11Version0​(java.lang.String option, java.lang.String startPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Find a free (unprogrammed) item.
    Specified by:
      `command107Variant11Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - 'X' Find the first free (unprogrammed) item. If the PLU parameter is set, the first free (not programmed) item with a number greater than or equal to it is returned. If missing, default is PLU = 1.

      'X' Find the last available (not programmed) item.

      `startPLU` -
    Returns:
      _ If the startPLU parameter is set, it returns the first free (not programmed) item with a number greater than or equal to him. If missing, default is PLU = 1.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant12Version0

    public FiscalResponse command107Variant12Version0​(java.lang.String PLU, java.lang.String price) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Bh (107) DEFINING AND READING ARTICLES Set the price of an item
    Specified by:
      `command107Variant12Version0` in class `FiscalPrinterV1`
    Parameters:
      `PLU` - Article Number (1 to 999999999)
      `price` - Unit price. Up to 8 significant digits.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command108Variant0Version0

    public FiscalResponse command108Variant0Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Ch (108) EXTENDED DAILY FINANCIAL REPORT The command has the same syntax as command 69 (45H), * but at the beginning of the daily report a report of * items for which there are sales for the day.
    Specified by:
      `command108Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `option` - '0' Z-report is printed. The printout ends with the inscription "FISCAL RECEIPT". '2' A daily financial report is made without resetting (ie no entry is made in fiscal memory and register reset). The printout ends with a logo "NON FISCAL RECEIPT".

      The presence of the symbol N at the end of the data prohibits the clearing of the accumulated ones data by operators in a reset report.

    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command109Variant0Version0

    public FiscalResponse command109Variant0Version0​(java.lang.String count) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Dh (109) PRINT A DUPLICATE RECEIPT
    Specified by:
      `command109Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `count` - Number of duplicate receipts (accepts only 1 as a value!).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant0Version0

    public FiscalResponse command110Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Eh (110) PAYMENT INFORMATION BY TYPE FOR THE DAY
    Specified by:
      `command110Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - Cash - Paid in cash Credit - On credit Debit - With debit card Check - Paid by check PayX - Paid by any of the additional types of payment 1-4 Closure Current (last) fiscal record Receipt - Number of the next fiscal receipt
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant1Version0

    public FiscalResponse command110Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Eh (110) PAYMENT INFORMATION BY TYPE FOR THE DAY All 11 additional payment types are returned.
    Specified by:
      `command110Variant1Version0` in class `FiscalPrinterV1`
    Returns:
      - Cash - Paid in cash Credit - On credit (Additional payment 1) Debit - With debit card (Additional payment 2) Check - Paid by check (Additional payment 3) PayX - Paid for one of the additional types of payment 5-11 Closure - Current (last) fiscal record Receipt - Number of the next fiscal receipt
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command111Variant0Version0

    public FiscalResponse command111Variant0Version0​(java.lang.String reportType, java.lang.String firstPLU, java.lang.String lastPLU, java.lang.String group) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    6Fh (111) PLU (ARTICLE) REPORT
    Specified by:
      `command111Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `reportType` - Specifies the type of information to be printed. Possible values: -- 'S' Prints only the PLUs having sales for the day. For each PLU, prints the code, tax group, product group, name, unit price, sold quantity and sales. --'P' All PLUs with their codes, tax groups, product groups, names, sold quantities, available quantities and unit prices are printed. --'@S' Only the FTT codes having sales for the day are printed. For each FTT, prints the code, tax group, name, unit price, sold quantity and sales. --'@P' All programmed FTT codes, tax groups, names and unit prices are printed.
      `firstPLU` - Initial number of the item to be included in the report. The default is 1.
      `lastPLU` - Last item number to include in the report. The default is 999999999.
      `group` - Number from 1 to 9. If this parameter is set, only items from this group are include in the report, otherwise all groups are printed.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command112Variant0Version0

    public FiscalResponse command112Variant0Version0​(java.lang.String operator) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    70h (112) OBTAIN OPERATOR INFORMATION
    Specified by:
      `command112Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `operator` - Operator number (1 to 16).
    Returns:
      - Operator - Operator ID (between 1 and 16). Receipts - Number of fiscal receipts issued by the operator. Total - Number of sales and accumulated total, separated by ';'. Discount - Number of discounts and discount total. Surcharge - Number of mark-ups and mark-up total. Void - Number of adjustments and adjustment total. Name - Operator name. Password - Operator password. Returned only if the printer has the service jumper installed.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command113Variant0Version0

    public FiscalResponse command113Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    71h (113) OBTAIN THE LAST PRINTED DOCUMENT NUMBER
    Specified by:
      `command113Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      DocNum Number of the last issued document (7 digits).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant0Version0

    public FiscalResponse command114Variant0Version0​(java.lang.String Rec1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) INFORMATION ON A FISCAL RECORD OR FISCAL PERIOD Information on the active tax rates for the Z-report record in question.
    Specified by:
      `command114Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Rec1` - Fiscal memory record number
    Returns:
      -

      ErrorCode One byte with a value of: 'P' The data are valid. 'F' Invalid record checksum. No data. 'E' No such record exists. No data. DecRecLast - (active) record with tax rates DecimalsCount - Number of decimal digits for the specified Z-report record. VATEnabled - Enabled tax rates: 8 bytes with a value of '0' or '1' where '1' means "enabled". PercX Tax rate for the respective tax group, as a percentage DT Date and time of the data in the following format: DD-MM-YY hh:mm:ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant1Version0

    public FiscalResponse command114Variant1Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the sales for the specified record or period
    Specified by:
      `command114Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FM record number.
      `closure2` - Record number from FM.
    Returns:
      -

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. TotX - Sales for the respective tax group.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant1Version1

    public FiscalResponse command114Variant1Version1​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Reversal (storno) information for the specified record or period.
    Specified by:
      `command114Variant1Version1` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FM record number.
      `closure2` - Record number from FM.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant2Version0

    public FiscalResponse command114Variant2Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on net amounts for the specified record or period.
    Specified by:
      `command114Variant2Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. Closure Number of fiscal records for the specified period. Receipts Number of receipts. NetX Turnover for the respective tax group.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant3Version0

    public FiscalResponse command114Variant3Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the charged VAT for the specified record or period.
    Specified by:
      `command114Variant3Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. DecRec Last (active) entry with tax rates. DecimalsCount Number of decimal places for the specified Z-report record. VATEnabled Allowed tax rates - 8 bytes with st-st '0' or '1', where '1' means 'allowed'. PercX Tax rate for the respective tax group in percentages. DT Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant4Version0

    public FiscalResponse command114Variant4Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Additional information about the specified entry.
    Specified by:
      `command114Variant4Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. DecRec Last (active) entry with tax rates. DecimalsCount Number of decimal places for the specified Z-report record. VATEnabled Allowed tax rates - 8 bytes with st-st '0' or '1', where '1' means 'allowed'. PercX Tax rate for the respective tax group in percentages. DT Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant5Version0

    public FiscalResponse command114Variant5Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified entry from the fiscal memory for setting tax rates
    Specified by:
      `command114Variant5Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
    Returns:
      _

      ErrorCode One byte with value: â€¢ 'P' Data is valid. â€¢ 'F' Invalid record checksum. No data. â€¢ 'E' No such entry. No data. DecimalsCount Number of decimal places for the specified Z-report record. VATEnabled Allowed tax rates - 8 bytes with st-st '0' or '1', where '1' means 'allowed'. PercX Tax rate for the respective tax group in percentages. DT Date and time of the data in the format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant6Version0

    public FiscalResponse command114Variant6Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the specified FP record with RAM reset.
    Specified by:
      `command114Variant6Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. DT- Date and time of data in format: DD-MM-YY hh: mm: ss.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant7Version0

    public FiscalResponse command114Variant7Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period
    Specified by:
      `command114Variant7Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. CashP Paid in cash. CardP Paid with debit card. CredP Paid by credit card. CheqP Paid by check. APaydx Additional payment types

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant8Version0

    public FiscalResponse command114Variant8Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period.
    Specified by:
      `command114Variant8Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. DiscC Number of discounts DiscS Accumulated amount of discounts MkUpC Number of allowances MkUpS Accumulated amount of allowances VoidC Number of corrections VoidS Total amount of adjustments. CanC Number of canceled receipts CanS Total amount of canceled receipts

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant9Version0

    public FiscalResponse command114Variant9Version0​(java.lang.String closure1, java.lang.String closure2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information about the amounts by type of payment for the specified record or period. Official introductions and amount.
    Specified by:
      `command114Variant9Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
      `closure2` - Record number from FP.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. InC Number of official entries InS Amount of official entries OutC Number of service outputs OutS Amount of service outputs

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command114Variant10Version0

    public FiscalResponse command114Variant10Version0​(java.lang.String closure1) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    72h (114) FISCAL RECORD OR FISCAL PERIOD INFORMATION Information on the total turnover and VAT up to the specified Z-report
    Specified by:
      `command114Variant10Version0` in class `FiscalPrinterV1`
    Parameters:
      `closure1` - FP record number.
    Returns:
      _

      ErrorCode One byte with value: 'P' - The command was executed successfully. Data follows. 'F' - Invalid record checksum. No data. 'E' - No such entry. No data. GTotal Accumulated turnover up to and including the specified daily report. GVAT Accumulated VAT up to and including the specified daily report.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command115Variant0Version0

    public FiscalResponse command115Variant0Version0​(java.lang.String rowNum, java.lang.String data) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    73h (115) GRAPHIC LOGO PROGRAMMING
    Specified by:
      `command115Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `rowNum` - The line being programmed. Number between 0 and 95.
      `data` - Graphic data. Set as hexadecimals, two characters for each byte of information. The data length is up to 72 bytes. If it is less than that, the data are automatically padded with 00.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command115Variant1Version0

    public FiscalResponse command115Variant1Version0​(java.lang.String rowNum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    73h (115) GRAPHIC LOGO READING Returns the contents of the respective graphic line in hexadecimal form.
    Specified by:
      `command115Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `rowNum` - The line to read. Number between 0 and 95.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command117Variant0Version0

    public FiscalResponse command117Variant0Version0​(java.lang.String N, java.lang.String reportType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    76h (118) DAILY FINANCIAL REPORT WITH DEPARTMENT The command is identical to 69 (45h) from the previous version, the only difference being that, at the top of the daily report, it additionally prints the departments having sales for the day and the PLUs with codes between 1 and 40, if they have sales. Command 69 is left unchanged. Commands 69, 108, 117 and 118 with option '0' (daily financial report with reset) reset the accumulated department data as well.
    Specified by:
      `command117Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `N` - The presence of this symbol prohibits the clearing of accumulated data by operators in a reset report.
      `reportType` - The command has the same syntax as command 69 (45H), Before the daily report a report by departments is printed, for which there are sales for the day.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command118Variant0Version0

    public FiscalResponse command118Variant0Version0​(java.lang.String N, java.lang.String reportType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    76h (118) DAILY FINANCIAL REPORT WITH DEPARTMENT AND PLU PRINTING
    Specified by:
      `command118Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `N` - The presence of this symbol prohibits the clearing of accumulated * data by operators in a reset report.
      `reportType` - The command has the same syntax as command 69 (45H), Before the daily report, the reports by departments and are printed articles.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant0Version0

    public FiscalResponse command119Variant0Version0​(java.lang.String Flg, java.lang.String DT1, java.lang.String DT2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS

    Reading data from EJ by date and time Returns the first line of a document with date and time DT1 and sets end to search for a document with date and time DT2 (inclusive). The following lines are drawn by sending a class 'N' command. Input argument format: command119Variant0Version1

    Specified by:
      `command119Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Flg` - Character specifying the document type to be selected for reading: 'A' All document types 'B' All documents issued from PinPad. 'F' Fiscal (customer) receipts. 'V' Refund (storno) receipts. 'C' Cancelled (customer) receipts. 'N' Service receipts. 'I' Service deposit receipts. 'O' Service withdrawal receipts. 'R' Service receipts with 90-degree rotated printing. 'S' Service operation receipts. 'P' Reports (only date/time and receipt number information) 'X' X-reports. 'Z' Z-reports
      `DT1` - Start date and time of the report in DDMMYY format [hhmmss]. If the hour is missed, it means "000000", ie 00:00:00.
      `DT2` - End date and time of the report in DDMMYY format [hhmmss]. If the hour is missed, it means "235959", ie 23:59:59.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant1Version0

    public FiscalResponse command119Variant1Version0​(java.lang.String Fnt, java.lang.String Flg, java.lang.String DT1, java.lang.String DT2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS

    Printing data from EJ by date and time Prints the documents with dates and times between DT1 and DT2 inclusive. A filter is applied to the selected documents, depending on the Flg argument. Input argument format:

    Specified by:
      `command119Variant1Version0` in class `FiscalPrinterV1`
    Parameters:
      `Fnt` - Optional parameter to request printing the EJ documents with a different font size, if the printer allows. One byte with the following allowed values:

      Vive la France !

      Print with a normal font size. Print with a Ð… font size.
      `Flg` - Character specifying the document type to be selected for reading: 'A' All document types 'B' All documents issued from PinPad. 'F' Fiscal (customer) receipts. 'V' Refund (storno) receipts. 'C' Cancelled (customer) receipts. 'N' Service receipts. 'I' Service deposit receipts. 'O' Service withdrawal receipts. 'R' Service receipts with 90-degree rotated printing. 'S' Service operation receipts. 'P' Reports (only date/time and receipt number information) 'X' X-reports. 'Z' Z-reports
      `DT1` - Start date and time of the report in DDMMYY format [hhmmss]. If the hour is missed, it means "000000", ie 00:00:00.
      `DT2` - End date and time of the report in DDMMYY format [hhmmss]. If the hour is missed, it means "235959", ie 23:59:59.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant2Version0

    public FiscalResponse command119Variant2Version0​(java.lang.String Flg, java.lang.String D1, java.lang.String D2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS

    Returns the first line of document number D1 and sets the end of the search for document D2 (inclusive). If the second argument is omitted, only one document is selected - D1.

    Specified by:
      `command119Variant2Version0` in class `FiscalPrinterV1`
    Parameters:
      `Flg` - Character specifying the document type to be selected for reading: 'A' All document types 'B' All documents issued from PinPad. 'F' Fiscal (customer) receipts. 'V' Refund (storno) receipts. 'C' Cancelled (customer) receipts. 'N' Service receipts. 'I' Service deposit receipts. 'O' Service withdrawal receipts. 'R' Service receipts with 90-degree rotated printing. 'S' Service operation receipts. 'P' Reports (only date/time and receipt number information) 'X' X-reports. 'Z' Z-reports
      `D1` - First document number in the EJ.
      `D2` - Last document number in the EJ.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant3Version0

    public FiscalResponse command119Variant3Version0​(java.lang.String Fnt, java.lang.String Flg, java.lang.String D1, java.lang.String D2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS

    Printing data from EJ by date and time Prints the documents between number D1 to number D2 inclusive.

    Specified by:
      `command119Variant3Version0` in class `FiscalPrinterV1`
    Parameters:
      `Flg` - Character specifying the document type to be selected for reading: 'A' All document types 'B' All documents issued from PinPad. 'F' Fiscal (customer) receipts. 'V' Refund (storno) receipts. 'C' Cancelled (customer) receipts. 'N' Service receipts. 'I' Service deposit receipts. 'O' Service withdrawal receipts. 'R' Service receipts with 90-degree rotated printing. 'S' Service operation receipts. 'P' Reports (only date/time and receipt number information) 'X' X-reports. 'Z' Z-reports
      `D1` - First document number in the EJ.
      `D2` - Last document number in the EJ.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant4Version0

    public FiscalResponse command119Variant4Version0​(java.lang.String Flg, java.lang.String Cl, java.lang.String D1, java.lang.String D2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS

    Prints the documents between number D1 for a Z-report Cl to number D2 inclusive for the same Z-report. The document counter is for the Z-report, i.e., command "*5,1,3" will print the first three documents from Z-report number 5. If D2 is omitted, only one document is selected: D1. If both D1 and D2 are omitted, all documents for the Z-report are selected.

    Specified by:
      `command119Variant4Version0` in class `FiscalPrinterV1`
    Parameters:
      `Cl` - Z-report number in the EJ.
      `Flg` - Character specifying the document type to be selected for reading: 'A' All document types 'B' All documents issued from PinPad. 'F' Fiscal (customer) receipts. 'V' Refund (storno) receipts. 'C' Cancelled (customer) receipts. 'N' Service receipts. 'I' Service deposit receipts. 'O' Service withdrawal receipts. 'R' Service receipts with 90-degree rotated printing. 'S' Service operation receipts. 'P' Reports (only date/time and receipt number information) 'X' X-reports. 'Z' Z-reports
      `D1` - First document number in the EJ.
      `D2` - Last document number in the EJ.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant5Version0

    public FiscalResponse command119Variant5Version0​(java.lang.String Fnt, java.lang.String Flg, java.lang.String Cl, java.lang.String D1, java.lang.String D2) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS

    Prints the documents between number D1 for a Z-report Cl to number D2 inclusive for the same Z-report. The document counter is for the Z-report, i.e., command "*5,1,3" will print the first three documents from Z-report number 5. If D2 is omitted, only one document is selected: D1. If both D1 and D2 are omitted, all documents for the Z-report are selected.

    Specified by:
      `command119Variant5Version0` in class `FiscalPrinterV1`
    Parameters:
      `Cl` - Z-report
      `Flg` - Character specifying the document type to be selected for reading: 'A' All document types 'B' All documents issued from PinPad. 'F' Fiscal (customer) receipts. 'V' Refund (storno) receipts. 'C' Cancelled (customer) receipts. 'N' Service receipts. 'I' Service deposit receipts. 'O' Service withdrawal receipts. 'R' Service receipts with 90-degree rotated printing. 'S' Service operation receipts. 'P' Reports (only date/time and receipt number information) 'X' X-reports. 'Z' Z-reports
      `D1` - First document number in the EJ.
      `D2` - Last document number in the EJ.
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant6Version1

    public FiscalResponse command119Variant6Version1() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Reading the next text line by EJ. ATTENTION! Sending this command without a previous class 'R', setting the scope of the report, can lead to the reading of meaningless data!
    Specified by:
      `command119Variant6Version1` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant7Version0

    public FiscalResponse command119Variant7Version0​(java.lang.String Num) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Returns information from EJ for Z-report with number Num. Read the data from the specified Z-report as a document.
    Specified by:
      `command119Variant7Version0` in class `FiscalPrinterV1`
    Parameters:
      `Num` -
    Returns:
      Information about the intended Z-report: FDocs - Document number of the Z-report. DT - Date and time of the report in the format "DD-MM-YYYY hh: mm: ss". SK -40 characters - SHA-1 of the Z-report in hexadecimal form. F -No data found in MAPLE for this Z-report.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant8Version0

    public FiscalResponse command119Variant8Version0​(java.lang.String X) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Information about EJ
    Specified by:
      `command119Variant8Version0` in class `FiscalPrinterV1`
    Parameters:
      `X` -
    Returns:
      - Tot Total size of the control strip in bytes. Used Used control strip size in bytes. C1 - -First number of Z-report in EJ. C2 - Last Z-report number in EJ. D1 - First document number in EJ. D2 - Last document number in EJ.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant9Version0

    public FiscalResponse command119Variant9Version0​(java.lang.String All) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Check the validity of EJ or part of it.
    Specified by:
      `command119Variant9Version0` in class `FiscalPrinterV1`
    Parameters:
      `All` - if the optional character '#' is present, it prints information on all found SHA-1, whether valid or not.
    Returns:
      Information about the intended Z-report: FDocs - Document number of the Z-report. DT - Date and time of the report in the format "DD-MM-YYYY hh: mm: ss". SK -40 characters - SHA-1 of the Z-report in hexadecimal form. F -No data found in MAPLE for this Z-report.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant10Version0

    public FiscalResponse command119Variant10Version0​(java.lang.String FirstDoc, java.lang.String LastDoc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Return structured information - First Line
    Specified by:
      `command119Variant10Version0` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant10Version1

    public FiscalResponse command119Variant10Version1() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Return structured information - Next Line
    Specified by:
      `command119Variant10Version1` in class `FiscalPrinterV1`
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant11Version0

    public FiscalResponse command119Variant11Version0​(java.lang.String StartDateTime, java.lang.String EndDateTime) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Return structured information: Find the first document between StartDateTime and EndDateTime and return the first text line of structured information. The date and time are in format: : "DD-MM-YYYY HH: MM: SS + pasted tab symbol". If you skip the hour, the start time is 00:00:00 and the end time is 23:59:59.
    Specified by:
      `command119Variant11Version0` in class `FiscalPrinterV1`
    Returns:
      Data - The data returned in the order described below is separated by a tab symbol enclosed in quotation marks. errCode - "P" The command is successful."F" - The command is unsuccessful or no data recDateTime - first receipt date time serialNumber - fiscal device ID; recType - Ð¤Ð‘ -fiscal receipt), Ð Ð¤Ð‘ -Invoice), Ð¡Ð¤Ð‘ -Refund receipt) or Ð Ð¤Ð‘ -Credit notification); recNumber - global number of receipt; unp- Unique Sale ID; productName - Stock/service - name; singlePrice - Stock/service â€“ single price; qty - Stock/service - quantity; price - Stock/service - price; total- total price for the receipt; invoiceNumber - Invoice number/Credit notification - if the entry is for Invoice or Credit notification; uic- UIC of recipient â€“ if the entry is for Invoice or Credit notification; docNumber - global number of the refund receipt â€“ if the entry is for Invoice or Credit notification; stornoInvoiceNumber- number of the refunded invoice â€“ if the entry is for Invoice or Credit notification; reasonOfStornoInvoice- reason for issue â€“ in case if entry is for refund receipt or Credit notification.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command119Variant11Version1

    public FiscalResponse command119Variant11Version1() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    77h (119) EJ OPERATIONS Return structured information: Return the next line of structured information
    Specified by:
      `command119Variant11Version1` in class `FiscalPrinterV1`
    Returns:
      Data - The data returned in the order described below is separated by a tab symbol enclosed in quotation marks. errCode - "P" The command is successful."F" - The command is unsuccessful or no data recDateTime - first receipt date time serialNumber - fiscal device ID; recType - Ð¤Ð‘ -fiscal receipt), Ð Ð¤Ð‘ -Invoice), Ð¡Ð¤Ð‘ -Refund receipt) or Ð Ð¤Ð‘ -Credit notification); recNumber - global number of receipt; unp- Unique Sale ID; productName - Stock/service - name; singlePrice - Stock/service â€“ single price; qty - Stock/service - quantity; price - Stock/service - price; total- total price for the receipt; invoiceNumber - Invoice number/Credit notification - if the entry is for Invoice or Credit notification; uic- UIC of recipient â€“ if the entry is for Invoice or Credit notification; docNumber - global number of the refund receipt â€“ if the entry is for Invoice or Credit notification; stornoInvoiceNumber- number of the refunded invoice â€“ if the entry is for Invoice or Credit notification; reasonOfStornoInvoice- reason for issue â€“ in case if entry is for refund receipt or Credit notification.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command148Variant0Version0

    public FiscalResponse command148Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    94H (148) Check recently recorded RRN code in fiscal printer with RRN from last transaction in payment terminal

    The fiscal device keeps the RRN code from the last successful transaction. If the last transaction was completed without a response from the payment terminal, during or without a printed receipt from the return purchase, the command compares the last recorded RRN code with that of the payment terminal. In the event of a malfunction, it returns an error and records from the payment terminal for verification with a command 95h(149): - type of transaction; - RRN code; - AC code; - amount; - the last four digits of the card number

    Specified by:
      `command148Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command149Variant0Version0

    public FiscalResponse command149Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    95H (149) Data for last transaction
    Specified by:
      `command149Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - CurrentRRN - last RRN code, saved in FD TransactionNo - transaction number RRN - RRN code of transaction AC - AC code of transaction Price - Amount CardNo - the last four digits of the card number
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command151Variant0Version0

    public FiscalResponse command151Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    97H (151) Prints the last successful transaction
    Specified by:
      `command151Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command152Variant0Version0

    public FiscalResponse command152Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    98H (152) Read the date and time of the payment terminal The command is forbidden in an open fiscal receipt.
    Specified by:
      `command152Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - DateTime YYYY-MM-DD HH:MM:SS
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command153Variant0Version0

    public FiscalResponse command153Variant0Version0​(java.lang.String DateTime) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    99H (153) Setting date and time of payment terminal The command is forbidden in an open fiscal receipt.
    Specified by:
      `command153Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `DateTime` - YY-MM-DD HH:MM:SS
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command154Variant0Version0

    public FiscalResponse command154Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    9AH (154) Test connection to a payment terminal * Checks whether the fiscal device is connected to a payment terminal. The command is forbidden in an open fiscal receipt.
    Specified by:
      `command154Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command155Variant0Version0

    public FiscalResponse command155Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    9BH (155) Number of entries in the payment terminal The command is forbidden in an open fiscal receipt.
    Specified by:
      `command155Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command156Variant0Version0

    public FiscalResponse command156Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    9CH (156) Payment terminal information Example: BluePad-50,0901900001,1.1.23.0,93800133,7 The command is forbidden in an open fiscal receipt.
    Specified by:
      `command156Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - Model - model of payment terminal SerialNo - payment terminal serial number SoftVer - software version of payment terminal TerminalId - ID of payment terminal MenuType - menu type of payment terminal F - No Data

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command157Variant0Version0

    public FiscalResponse command157Variant0Version0​(java.lang.String Batch) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    9DH (157) Set batch number The command is forbidden in an open fiscal receipt
    Specified by:
      `command157Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Batch` - - number up to 65535
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command158Variant0Version0

    public FiscalResponse command158Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    9EH (158) Transaction status (unsuccessful) The command is forbidden in an open fiscal receipt
    Specified by:
      `command158Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - Reversal - 00 â€“ no (unsuccessful) frozen transactions R â€“ (unsuccessful) freeze purchase C â€“ (unsuccessful) freeze reversal EndDay - 00 â€“ no need to close the day 01 â€“ day closing required

      errCode: F

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command159Variant0Version0

    public FiscalResponse command159Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    9FH (159) Delete batch

    Deletes all transactions from a payment terminal. The command is forbidden in an open fiscal receipt.

    Specified by:
      `command159Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command160Variant0Version0

    public FiscalResponse command160Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A0H (160) Deleting (unsuccessful) freeze transactions

    Deletes (unsuccessful) freeze transactions from a payment terminal, if any. The command is forbidden in an open fiscal receipt.

    Specified by:
      `command160Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command161Variant0Version0

    public FiscalResponse command161Variant0Version0​(java.lang.String Stan) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A1H (161) Establishing a receipt number

    The next receipt will be issued under the assigned number. The command is forbidden in an open fiscal receipt.

    Specified by:
      `command161Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Stan` - - receipt number up to 65535
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command162Variant0Version0

    public FiscalResponse command162Variant0Version0​(java.lang.String Num) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A2H (162) Print a receipt by number

    The command is forbidden in an open fiscal receipt.

    Specified by:
      `command162Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Num` - - receipt number up to 65535
    Returns:
      - errCode: P or F Ð•rr (Err can be text "No data for entered number" or error code.)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command163Variant0Version0

    public FiscalResponse command163Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A3H (163) Printing the last successful transaction in a payment terminal

    It can only be executed if a receipt is open and the last transaction is completed without a reply from a payment terminal. If the A4h command (164) has been executed before, or with card payment it will also be successfully rejected. The receipt is printed automatically after the fiscal receipt has been closed. Requires execution before returning command 148 for reference and return data collection.

    Specified by:
      `command163Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command164Variant0Version0

    public FiscalResponse command164Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A4H (164) Return the last successful transaction

    It can only be executed if a receipt is open and the last transaction is completed without a reply from a payment terminal. If the A3h command (163) was previously executed or the card payment is successful, it will also be rejected. The receipt is printed automatically after the fiscal receipt has been closed. Requires execution before returning command 148 for reference and return data.

    Specified by:
      `command164Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command165Variant0Version0

    public FiscalResponse command165Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A5H (165) Establishment of RRN code in FD with RRN code from payment terminal It is used when changing the Fiscal Device and / or payment terminal. The command is forbidden in an open fiscal receipt.
    Specified by:
      `command165Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command166Variant0Version0

    public FiscalResponse command166Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A6H (166) Test connection to server The command is forbidden in an open fiscal receipt.
    Specified by:
      `command166Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command167Variant0Version0

    public FiscalResponse command167Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A7H (167) Closing of the day

    The command first prints the (unsuccessful) freeze reversal receipts, then sends data to the server, and finishes with printing a short report in response to the successful or unsuccessful clearing of the registers. The command is forbidden in an open fiscal receipt.

    Specified by:
      `command167Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command168Variant0Version0

    public FiscalResponse command168Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A8H (168) Checking and updating of payment terminal software

    The command is forbidden in an open fiscal receipt.

    Specified by:
      `command168Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command169Variant0Version0

    public FiscalResponse command169Variant0Version0​(java.lang.String Type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    A9H (169) Reports The command is forbidden in an open fiscal receipt.
    Specified by:
      `command169Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Type` - 1 â€“ short report, 2 â€“ extended report
    Returns:
      - errCode: P or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command172Variant0Version0

    public FiscalResponse command172Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    ACH (172) Status of last transaction

    The command is forbidden in an open fiscal receipt.

    Specified by:
      `command172Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - Timeout - flag, if its value is 1, then the previous transaction ended with timeout voidReceiptPrint - flag, if its value is 1, then the previous transaction was a reversal and the purchase - reversal receipt was not printed. Ð¸nTransaction - flag, if its value is 1, then the printer power was turned off before the end of the printer transaction.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command173Variant0Version0

    public FiscalResponse command173Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    ADH (173) Clearing transaction status flags

    Clears the flags specified in the command 172. The command is forbidden in an open fiscal recei

    Specified by:
      `command173Variant0Version0` in class `FiscalPrinterV1`
    Returns:
      - P
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command174Variant0Version0

    public FiscalResponse command174Variant0Version0​(java.lang.String Opt, java.lang.String NumReceipts) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    AEH (174) Header printing options The command is forbidden in an open fiscal receipt
    Specified by:
      `command174Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `Opt` - number in the range [0 - 4], which determines the printing of the header in repeated receipt information (city, address, po box, phone.) or setting the number of printed repeated receipts: 0 â€“ short repeated receipt; 1 â€“ full information: 2 â€“ full information without phone: 3 - the current status of the print options and the number of repeated receipts 4 - allows to set the number of repeated receipts
      `NumReceipts` - number representing the number of repeat receipts - max10
    Returns:
      - P - Or CurrentOpt - current print option CurrentNumReceipts - the current number of reprinted
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command175Variant0Version0

    public FiscalResponse command175Variant0Version0​(java.lang.String CpNum) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    AFH (175) Printing a copy of an receipt from the EJ
    Specified by:
      `command175Variant0Version0` in class `FiscalPrinterV1`
    Parameters:
      `CpNum` - Global number of original receipt
    Returns:
      - P - Or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command175Variant0Version1

    public FiscalResponse command175Variant0Version1​(java.lang.String CpDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    AFH (175) Printing a copy of an receipt from the EJ
    Specified by:
      `command175Variant0Version1` in class `FiscalPrinterV1`
    Parameters:
      `CpDate` - - Date and time of original receipt in format DDMMYYhhmmss.
    Returns:
      - P - Or F
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### getMaxHeaderLines

    public int getMaxHeaderLines()
    Overrides:
      `getMaxHeaderLines` in class `FiscalPrinterV1`

  - ### getMaxFooterLines

    public int getMaxFooterLines()
    Overrides:
      `getMaxFooterLines` in class `FiscalPrinterV1`

  - ### getMaxLogoHeightPixel

    public int getMaxLogoHeightPixel()
    Specified by:
      `getMaxLogoHeightPixel` in class `FiscalPrinterV1`

  - ### getMaxLogoWidthPixel

    public int getMaxLogoWidthPixel()
    Specified by:
      `getMaxLogoWidthPixel` in class `FiscalPrinterV1`

  - ### getMaxBarcodeHeight_mm

    public int getMaxBarcodeHeight_mm()
    Specified by:
      `getMaxBarcodeHeight_mm` in class `FiscalPrinterV1`

  - ### getMinBarcodeHeight_mm

    public int getMinBarcodeHeight_mm()
    Specified by:
      `getMinBarcodeHeight_mm` in class `FiscalPrinterV1`

  - ### getLogoROW_NUM

    public int getLogoROW_NUM()
    Specified by:
      `getLogoROW_NUM` in class `FiscalPrinterV1`

  - ### getcapFontSupported

    public boolean getcapFontSupported()
    Specified by:
      `getcapFontSupported` in class `FiscalPrinterV1`

  - ### getCapAutoCutter

    public boolean getCapAutoCutter()
    Overrides:
      `getCapAutoCutter` in class `FiscalPrinterV1`

  - ### getPrintColumns

    public int getPrintColumns()
    Specified by:
      `getPrintColumns` in class `FiscalPrinterV1`

  - ### getMaxNonFiscalText

    public int getMaxNonFiscalText()
    Specified by:
      `getMaxNonFiscalText` in class `FiscalPrinterV1`

  - ### isPaperCuttingDevice

    public boolean isPaperCuttingDevice()
    Specified by:
      `isPaperCuttingDevice` in class `FiscalPrinterV1`